/* Generated by re2c 1.1.1 on Mon Aug 16 03:01:00 2021 */
#line 1 "tokenizer.re"
#include <limits>

#include "tokenizer.h"
#include <lfortran/bigint.h>
#include "parser.tab.hh"

namespace LFortran
{

void lex_format(unsigned char *&cur, Location &loc,
        unsigned char *&start);

void Tokenizer::set_string(const std::string &str)
{
    // The input string must be NULL terminated, otherwise the tokenizer will
    // not detect the end of string. After C++11, the std::string is guaranteed
    // to end with \0, but we check this here just in case.
    LFORTRAN_ASSERT(str[str.size()] == '\0');
    cur = (unsigned char *)(&str[0]);
    cur_line = cur;
    line_num = 1;
}

template<int base>
bool adddgt(uint64_t &u, uint64_t d)
{
    if (u > (std::numeric_limits<uint64_t>::max() - d) / base) {
        return false;
    }
    u = u * base + d;
    return true;
}

bool lex_dec(const unsigned char *s, const unsigned char *e, uint64_t &u)
{
    for (u = 0; s < e; ++s) {
        if (!adddgt<10>(u, *s - 0x30u)) {
            return false;
        }
    }
    return true;
}

// Tokenizes integer of the kind 1234_ikind into `u` and `suffix`
// s ... the start of the integer
// e ... the character after the end
bool lex_int(const unsigned char *s, const unsigned char *e, uint64_t &u,
    Str &suffix)
{
    for (u = 0; s < e; ++s) {
        if (*s == '_') {
            s++;
            suffix.p = (char*) s;
            suffix.n = e-s;
            return true;
        } else if (!adddgt<10>(u, *s - 0x30u)) {
            return false;
        }
    }
    suffix.p = nullptr;
    suffix.n = 0;
    return true;
}

void lex_int_large(Allocator &al, const unsigned char *s,
    const unsigned char *e, BigInt::BigInt &u, Str &suffix)
{
    uint64_t ui;
    if (lex_int(s, e, ui, suffix)) {
        if (ui <= BigInt::MAX_SMALL_INT) {
            u.from_smallint(ui);
            return;
        }
    }
    const unsigned char *start = s;
    for (; s < e; ++s) {
        if (*s == '_') {
            s++;
            suffix.p = (char*) s;
            suffix.n = e-s;

            Str num;
            num.p = (char*)start;
            num.n = s-start-1;
            u.from_largeint(al, num);
            return;
        }
    }
    suffix.p = nullptr;
    suffix.n = 0;
    Str num;
    num.p = (char*)start;
    num.n = e-start;
    u.from_largeint(al, num);
}

uint64_t parse_int(const unsigned char *s)
{
    while (*s == ' ') s++;
    uint64_t u;
    for (u = 0; ; ++s) {
        if (*s >= '0' && *s <= '9') {
            if (!adddgt<10>(u, *s - 0x30u)) {
                return false;
            }
        } else {
            return u;
        }
    }
}

#define KW(x) token(yylval.string); RET(KW_##x);
#define RET(x) token_loc(loc); last_token=yytokentype::x; return yytokentype::x;

int Tokenizer::lex(Allocator &al, YYSTYPE &yylval, Location &loc)
{
    if (enddo_state == 1) {
        enddo_state = 2;
        KW(END_DO)
    } else if (enddo_state == 2) {
        enddo_insert_count--;
        if (enddo_insert_count > 0) {
            enddo_state = 1;
        } else {
            enddo_state = 0;
            token_loc(loc); line_num++; cur_line=cur;
            last_token = yytokentype::TK_NEWLINE;
        }
        return yytokentype::TK_NEWLINE;
    }
    for (;;) {
        tok = cur;

        /*
        Re2c has excellent documentation at:

        https://re2c.org/manual/manual_c.html

        The first paragraph there explains the basics:

        * If multiple rules match, the longest match takes precedence
        * If multiple rules match the same string, the earlier rule takes
          precedence
        * Default rule `*` should always be defined, it has the lowest priority
          regardless of its place and matches any code unit
        * We use the "Sentinel character" method for end of input:
            * The end of the input text is denoted with a null character \x00
            * Thus the null character cannot be part of the input otherwise
            * There is one rule to match \x00 to end the parser
            * No other rule is allowed to match \x00, otherwise the re2c block
              would parse past the end of the string and segfaults
            * A special case of the previous point are negated character
              ranges, such as [^"\x00], where one must include \x00 in it to
              ensure this rule does not match \x00 (all other rules simply do
              not mention \x00)
            * See the "Handling the end of input" section in the re2c
              documentation for more info

        The re2c block interacts with the rest of the code via just one pointer
        variable `cur`. On entering the re2c block, the `cur` variable must
        point to the first character of the token to be tokenized by the block.
        The re2c block below then executes on its own until a rule is matched:
        the action in {} is then executed. In that action `cur` points to the
        first character of the next token.

        Before the re2c block we save the current `cur` into `tok`, so that we
        can use `tok` and `cur` in the action in {} to extract the token that
        corresponds to the rule that got matched:

        * `tok` points to the first character of the token
        * `cur-1` points to the last character of the token
        * `cur` points to the first character of the next token
        * `cur-tok` is the length of the token

        In the action, we do one of:

        * call `continue` which executes another cycle in the for loop (which
          will parse the next token); we use this to skip a token
        * call `return` which returns from this function; we return a token
        * throw an exception (terminates the tokenizer)

        In the first two cases, `cur` points to first character of the next
        token, which becomes `tok` at the next iteration of the loop (either
        right away after `continue` or after the `lex` function is called again
        after `return`).

        See the manual for more details.
        */


        // These two variables are needed by the re2c block below internally,
        // initialization is not needed. One can think of them as local
        // variables of the re2c block.
        unsigned char *mar, *ctxmar;
        
#line 199 "tokenizer.cpp"
{
	unsigned char yych;
	unsigned int yyaccept = 0;
	static const unsigned char yybm[] = {
		/* table 1 .. 8: 0 */
		  0,   2,   2,   2,   2,   2,   2,   2, 
		  2,   3,   3,   3,   2,   3,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  3,   2,   2,   2,   2,   2,   2,   0, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		242, 242, 210, 210, 210, 210, 210, 210, 
		146, 146,   2,   2,   2,   2,   2,   2, 
		  2, 150, 150, 150, 150, 150, 150,  22, 
		 22,  22,  22,  22,  22,  22,  22,  22, 
		 22,  22,  22,  22,  22,  22,  22,  22, 
		 22,  22,  22,   2,   2,   2,   2,  26, 
		  2, 150, 150, 150, 150, 150, 150,  22, 
		 22,  22,  22,  22,  22,  22,  22,  22, 
		 22,  22,  22,  22,  22,  22,  22,  22, 
		 22,  22,  22,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		/* table 9 .. 13: 256 */
		  0, 192, 192, 192, 192, 192, 192, 192, 
		192, 200, 128, 200, 192, 200, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		200, 192,  64, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		240, 240, 240, 240, 240, 240, 240, 240, 
		240, 240, 192, 192, 192, 192, 192, 192, 
		192, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 192, 192, 192, 192, 192, 
		192, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
	};
	yych = *cur;
	if (yybm[256+yych] & 8) {
		goto yy6;
	}
	switch (yych) {
	case 0x00:	goto yy2;
	case '\t':
	case '\n':	goto yy9;
	case ' ':
	case '!':	goto yy11;
	case '"':	goto yy12;
	case '#':	goto yy13;
	case '%':	goto yy14;
	case '&':	goto yy16;
	case '\'':	goto yy17;
	case '(':	goto yy18;
	case ')':	goto yy20;
	case '*':	goto yy22;
	case '+':	goto yy24;
	case ',':	goto yy26;
	case '-':	goto yy28;
	case '.':	goto yy30;
	case '/':	goto yy31;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy33;
	case ':':	goto yy36;
	case ';':	goto yy38;
	case '<':	goto yy40;
	case '=':	goto yy42;
	case '>':	goto yy44;
	case 'A':
	case 'a':	goto yy46;
	case 'B':
	case 'b':	goto yy48;
	case 'C':
	case 'c':	goto yy49;
	case 'D':
	case 'd':	goto yy50;
	case 'E':
	case 'e':	goto yy51;
	case 'F':
	case 'f':	goto yy52;
	case 'G':
	case 'g':	goto yy53;
	case 'H':
	case 'J':
	case 'X':
	case 'Y':
	case '_':
	case 'h':
	case 'j':
	case 'x':
	case 'y':	goto yy54;
	case 'I':
	case 'i':	goto yy56;
	case 'K':
	case 'k':	goto yy57;
	case 'L':
	case 'l':	goto yy58;
	case 'M':
	case 'm':	goto yy59;
	case 'N':
	case 'n':	goto yy60;
	case 'O':
	case 'o':	goto yy61;
	case 'P':
	case 'p':	goto yy62;
	case 'Q':
	case 'q':	goto yy63;
	case 'R':
	case 'r':	goto yy64;
	case 'S':
	case 's':	goto yy65;
	case 'T':
	case 't':	goto yy66;
	case 'U':
	case 'u':	goto yy67;
	case 'V':
	case 'v':	goto yy68;
	case 'W':
	case 'w':	goto yy69;
	case 'Z':
	case 'z':	goto yy70;
	case '[':	goto yy71;
	case ']':	goto yy73;
	case '|':	goto yy75;
	default:	goto yy4;
	}
yy2:
	++cur;
#line 224 "tokenizer.re"
	{ RET(END_OF_FILE); }
#line 371 "tokenizer.cpp"
yy4:
	++cur;
yy5:
#line 219 "tokenizer.re"
	{ token_loc(loc);
                std::string t = token();
                throw LFortran::TokenizerError("token '" + t
                    + "' is not recognized", loc, t);
            }
#line 381 "tokenizer.cpp"
yy6:
	yych = *++cur;
	if (yybm[256+yych] & 8) {
		goto yy6;
	}
#line 225 "tokenizer.re"
	{ continue; }
#line 389 "tokenizer.cpp"
yy9:
	++cur;
#line 462 "tokenizer.re"
	{
                if (enddo_newline_process) {
                    enddo_newline_process = false;
                    enddo_state = 1;
                    return yytokentype::TK_NEWLINE;
                } else {
                    enddo_newline_process = false;
                    enddo_insert_count = 0;
                    token_loc(loc); line_num++; cur_line=cur;
                    last_token = yytokentype::TK_NEWLINE;
                    return yytokentype::TK_NEWLINE;
                }
            }
#line 406 "tokenizer.cpp"
yy11:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy5;
	goto yy78;
yy12:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy5;
	goto yy83;
yy13:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy5;
	goto yy87;
yy14:
	++cur;
#line 495 "tokenizer.re"
	{ RET(TK_PERCENT) }
#line 426 "tokenizer.cpp"
yy16:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= '\f') {
		if (yych <= 0x08) goto yy5;
		if (yych <= '\v') goto yy91;
		goto yy5;
	} else {
		if (yych <= '\r') goto yy91;
		if (yych <= 0x1F) goto yy5;
		if (yych <= '!') goto yy91;
		goto yy5;
	}
yy17:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy5;
	goto yy98;
yy18:
	yych = *++cur;
	if (yych == '/') {
		ctxmar = cur;
		goto yy101;
	}
#line 477 "tokenizer.re"
	{ RET(TK_LPAREN) }
#line 453 "tokenizer.cpp"
yy20:
	++cur;
#line 485 "tokenizer.re"
	{ RET(TK_RPAREN) }
#line 458 "tokenizer.cpp"
yy22:
	yych = *++cur;
	if (yych == '*') goto yy102;
#line 497 "tokenizer.re"
	{ RET(TK_STAR) }
#line 464 "tokenizer.cpp"
yy24:
	++cur;
#line 489 "tokenizer.re"
	{ RET(TK_PLUS) }
#line 469 "tokenizer.cpp"
yy26:
	++cur;
#line 496 "tokenizer.re"
	{ RET(TK_COMMA) }
#line 474 "tokenizer.cpp"
yy28:
	++cur;
#line 490 "tokenizer.re"
	{ RET(TK_MINUS) }
#line 479 "tokenizer.cpp"
yy30:
	yyaccept = 0;
	yych = *(mar = ++cur);
	switch (yych) {
	case '.':	goto yy104;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy106;
	case 'A':
	case 'a':	goto yy109;
	case 'B':
	case 'C':
	case 'D':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'M':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case 'b':
	case 'c':
	case 'd':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'm':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy110;
	case 'E':
	case 'e':	goto yy112;
	case 'F':
	case 'f':	goto yy113;
	case 'G':
	case 'g':	goto yy114;
	case 'L':
	case 'l':	goto yy115;
	case 'N':
	case 'n':	goto yy116;
	case 'O':
	case 'o':	goto yy117;
	case 'T':
	case 't':	goto yy118;
	default:	goto yy5;
	}
yy31:
	yych = *++cur;
	if (yych <= '.') {
		if (yych == ')') goto yy119;
	} else {
		if (yych <= '/') goto yy121;
		if (yych == '=') goto yy123;
	}
#line 494 "tokenizer.re"
	{ RET(TK_SLASH) }
#line 559 "tokenizer.cpp"
yy33:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yybm[256+yych] & 16) {
		goto yy33;
	}
	if (yych <= ' ') {
		if (yych <= '\v') {
			if (yych == '\t') {
				ctxmar = cur;
				goto yy125;
			}
			if (yych >= '\v') {
				ctxmar = cur;
				goto yy125;
			}
		} else {
			if (yych == '\r') {
				ctxmar = cur;
				goto yy125;
			}
			if (yych >= ' ') {
				ctxmar = cur;
				goto yy125;
			}
		}
	} else {
		if (yych <= 'E') {
			if (yych == '.') {
				ctxmar = cur;
				goto yy127;
			}
			if (yych >= 'D') goto yy128;
		} else {
			if (yych <= '_') {
				if (yych >= '_') goto yy129;
			} else {
				if (yych <= 'c') goto yy35;
				if (yych <= 'e') goto yy128;
			}
		}
	}
yy35:
#line 569 "tokenizer.re"
	{
                lex_int_large(al, tok, cur,
                    yylval.int_suffix.int_n,
                    yylval.int_suffix.int_kind);
                RET(TK_INTEGER)
            }
#line 610 "tokenizer.cpp"
yy36:
	yych = *++cur;
	if (yych == ':') goto yy130;
#line 492 "tokenizer.re"
	{ RET(TK_COLON) }
#line 616 "tokenizer.cpp"
yy38:
	++cur;
#line 493 "tokenizer.re"
	{ RET(TK_SEMICOLON) }
#line 621 "tokenizer.cpp"
yy40:
	yych = *++cur;
	if (yych == '=') goto yy132;
yy41:
#line 510 "tokenizer.re"
	{ RET(TK_LT) }
#line 628 "tokenizer.cpp"
yy42:
	yych = *++cur;
	if (yych <= '<') goto yy43;
	if (yych <= '=') goto yy134;
	if (yych <= '>') goto yy136;
yy43:
#line 491 "tokenizer.re"
	{ RET(TK_EQUAL) }
#line 637 "tokenizer.cpp"
yy44:
	yych = *++cur;
	if (yych == '=') goto yy138;
yy45:
#line 512 "tokenizer.re"
	{ RET(TK_GT) }
#line 644 "tokenizer.cpp"
yy46:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych <= 'K') {
			if (yych == 'B') goto yy140;
			goto yy55;
		} else {
			if (yych <= 'L') goto yy141;
			if (yych <= 'R') goto yy55;
			goto yy142;
		}
	} else {
		if (yych <= 'k') {
			if (yych == 'b') goto yy140;
			goto yy55;
		} else {
			if (yych <= 'l') goto yy141;
			if (yych == 's') goto yy142;
			goto yy55;
		}
	}
yy47:
#line 611 "tokenizer.re"
	{ token(yylval.string); RET(TK_NAME) }
#line 669 "tokenizer.cpp"
yy48:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych <= 'I') {
		if (yych <= '\'') {
			if (yych == '"') goto yy145;
			if (yych <= '&') goto yy55;
			goto yy146;
		} else {
			if (yych == 'A') goto yy147;
			if (yych <= 'H') goto yy55;
			goto yy148;
		}
	} else {
		if (yych <= 'a') {
			if (yych == 'L') goto yy149;
			if (yych <= '`') goto yy55;
			goto yy147;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy55;
				goto yy148;
			} else {
				if (yych == 'l') goto yy149;
				goto yy55;
			}
		}
	}
yy49:
	yych = *++cur;
	switch (yych) {
	case 'A':
	case 'a':	goto yy150;
	case 'H':
	case 'h':	goto yy151;
	case 'L':
	case 'l':	goto yy152;
	case 'O':
	case 'o':	goto yy153;
	case 'R':
	case 'r':	goto yy154;
	case 'Y':
	case 'y':	goto yy155;
	default:	goto yy55;
	}
yy50:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych <= 'E') {
			if (yych == 'A') goto yy156;
			if (yych <= 'D') goto yy55;
			goto yy157;
		} else {
			if (yych == 'I') goto yy158;
			if (yych <= 'N') goto yy55;
			goto yy159;
		}
	} else {
		if (yych <= 'e') {
			if (yych == 'a') goto yy156;
			if (yych <= 'd') goto yy55;
			goto yy157;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy55;
				goto yy158;
			} else {
				if (yych == 'o') goto yy159;
				goto yy55;
			}
		}
	}
yy51:
	yych = *++cur;
	switch (yych) {
	case 'L':
	case 'l':	goto yy161;
	case 'N':
	case 'n':	goto yy162;
	case 'Q':
	case 'q':	goto yy163;
	case 'R':
	case 'r':	goto yy164;
	case 'V':
	case 'v':	goto yy165;
	case 'X':
	case 'x':	goto yy166;
	default:	goto yy55;
	}
yy52:
	yych = *++cur;
	switch (yych) {
	case 'I':
	case 'i':	goto yy167;
	case 'L':
	case 'l':	goto yy168;
	case 'O':
	case 'o':	goto yy169;
	case 'U':
	case 'u':	goto yy170;
	default:	goto yy55;
	}
yy53:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'E') goto yy171;
		if (yych <= 'N') goto yy55;
		goto yy172;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy171;
		} else {
			if (yych == 'o') goto yy172;
			goto yy55;
		}
	}
yy54:
	yych = *++cur;
yy55:
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
	goto yy47;
yy56:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych <= 'L') {
			if (yych == 'F') goto yy174;
			goto yy55;
		} else {
			if (yych <= 'M') goto yy176;
			if (yych <= 'N') goto yy177;
			if (yych <= 'R') goto yy55;
			goto yy179;
		}
	} else {
		if (yych <= 'm') {
			if (yych == 'f') goto yy174;
			if (yych <= 'l') goto yy55;
			goto yy176;
		} else {
			if (yych <= 'n') goto yy177;
			if (yych == 's') goto yy179;
			goto yy55;
		}
	}
yy57:
	yych = *++cur;
	if (yych == 'I') goto yy181;
	if (yych == 'i') goto yy181;
	goto yy55;
yy58:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'E') goto yy182;
		if (yych <= 'N') goto yy55;
		goto yy183;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy182;
		} else {
			if (yych == 'o') goto yy183;
			goto yy55;
		}
	}
yy59:
	yych = *++cur;
	if (yych == 'O') goto yy184;
	if (yych == 'o') goto yy184;
	goto yy55;
yy60:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych <= 'N') {
			if (yych == 'A') goto yy185;
			goto yy55;
		} else {
			if (yych <= 'O') goto yy186;
			if (yych <= 'T') goto yy55;
			goto yy187;
		}
	} else {
		if (yych <= 'n') {
			if (yych == 'a') goto yy185;
			goto yy55;
		} else {
			if (yych <= 'o') goto yy186;
			if (yych == 'u') goto yy187;
			goto yy55;
		}
	}
yy61:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych <= 'P') {
		if (yych <= '\'') {
			if (yych == '"') goto yy188;
			if (yych <= '&') goto yy55;
			goto yy189;
		} else {
			if (yych == 'N') goto yy190;
			if (yych <= 'O') goto yy55;
			goto yy191;
		}
	} else {
		if (yych <= 'n') {
			if (yych == 'U') goto yy192;
			if (yych <= 'm') goto yy55;
			goto yy190;
		} else {
			if (yych <= 'p') {
				if (yych <= 'o') goto yy55;
				goto yy191;
			} else {
				if (yych == 'u') goto yy192;
				goto yy55;
			}
		}
	}
yy62:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych <= 'O') {
			if (yych == 'A') goto yy193;
			if (yych <= 'N') goto yy55;
			goto yy194;
		} else {
			if (yych == 'R') goto yy195;
			if (yych <= 'T') goto yy55;
			goto yy196;
		}
	} else {
		if (yych <= 'o') {
			if (yych == 'a') goto yy193;
			if (yych <= 'n') goto yy55;
			goto yy194;
		} else {
			if (yych <= 'r') {
				if (yych <= 'q') goto yy55;
				goto yy195;
			} else {
				if (yych == 'u') goto yy196;
				goto yy55;
			}
		}
	}
yy63:
	yych = *++cur;
	if (yych == 'U') goto yy197;
	if (yych == 'u') goto yy197;
	goto yy55;
yy64:
	yych = *++cur;
	if (yych <= 'E') {
		if (yych == 'A') goto yy198;
		if (yych <= 'D') goto yy55;
		goto yy199;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy198;
		} else {
			if (yych == 'e') goto yy199;
			goto yy55;
		}
	}
yy65:
	yych = *++cur;
	switch (yych) {
	case 'A':
	case 'a':	goto yy200;
	case 'E':
	case 'e':	goto yy201;
	case 'H':
	case 'h':	goto yy202;
	case 'O':
	case 'o':	goto yy203;
	case 'T':
	case 't':	goto yy204;
	case 'U':
	case 'u':	goto yy205;
	case 'Y':
	case 'y':	goto yy206;
	default:	goto yy55;
	}
yy66:
	yych = *++cur;
	switch (yych) {
	case 'A':
	case 'a':	goto yy207;
	case 'E':
	case 'e':	goto yy208;
	case 'H':
	case 'h':	goto yy209;
	case 'O':
	case 'o':	goto yy210;
	case 'Y':
	case 'y':	goto yy212;
	default:	goto yy55;
	}
yy67:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych == 'N') goto yy213;
		if (yych <= 'R') goto yy55;
		goto yy214;
	} else {
		if (yych <= 'n') {
			if (yych <= 'm') goto yy55;
			goto yy213;
		} else {
			if (yych == 's') goto yy214;
			goto yy55;
		}
	}
yy68:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'A') goto yy215;
		if (yych <= 'N') goto yy55;
		goto yy216;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy215;
		} else {
			if (yych == 'o') goto yy216;
			goto yy55;
		}
	}
yy69:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych <= 'G') {
			if (yych == 'A') goto yy217;
			goto yy55;
		} else {
			if (yych <= 'H') goto yy218;
			if (yych <= 'Q') goto yy55;
			goto yy219;
		}
	} else {
		if (yych <= 'g') {
			if (yych == 'a') goto yy217;
			goto yy55;
		} else {
			if (yych <= 'h') goto yy218;
			if (yych == 'r') goto yy219;
			goto yy55;
		}
	}
yy70:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych == '"') goto yy220;
	if (yych == '\'') goto yy221;
	goto yy55;
yy71:
	++cur;
yy72:
#line 486 "tokenizer.re"
	{ RET(TK_LBRACKET) }
#line 1035 "tokenizer.cpp"
yy73:
	++cur;
#line 487 "tokenizer.re"
	{ RET(TK_RBRACKET) }
#line 1040 "tokenizer.cpp"
yy75:
	++cur;
#line 498 "tokenizer.re"
	{ RET(TK_VBAR) }
#line 1045 "tokenizer.cpp"
yy77:
	yych = *++cur;
yy78:
	if (yybm[256+yych] & 64) {
		goto yy77;
	}
	if (yych >= 0x01) goto yy80;
yy79:
	cur = mar;
	if (yyaccept <= 8) {
		if (yyaccept <= 4) {
			if (yyaccept <= 2) {
				if (yyaccept <= 1) {
					if (yyaccept == 0) {
						goto yy5;
					} else {
						goto yy35;
					}
				} else {
					goto yy47;
				}
			} else {
				if (yyaccept == 3) {
					goto yy85;
				} else {
					goto yy94;
				}
			}
		} else {
			if (yyaccept <= 6) {
				if (yyaccept == 5) {
					goto yy100;
				} else {
					goto yy72;
				}
			} else {
				if (yyaccept == 7) {
					goto yy108;
				} else {
					goto yy160;
				}
			}
		}
	} else {
		if (yyaccept <= 13) {
			if (yyaccept <= 11) {
				if (yyaccept <= 10) {
					if (yyaccept == 9) {
						goto yy178;
					} else {
						goto yy290;
					}
				} else {
					goto yy722;
				}
			} else {
				if (yyaccept == 12) {
					goto yy855;
				} else {
					goto yy926;
				}
			}
		} else {
			if (yyaccept <= 15) {
				if (yyaccept == 14) {
					goto yy1016;
				} else {
					goto yy1094;
				}
			} else {
				if (yyaccept == 16) {
					goto yy1206;
				} else {
					goto yy1208;
				}
			}
		}
	}
yy80:
	++cur;
#line 587 "tokenizer.re"
	{
                line_num++; cur_line=cur;
                token(yylval.string);
                yylval.string.n--;
                token_loc(loc);
                if (last_token == yytokentype::TK_NEWLINE) {
                    return yytokentype::TK_COMMENT;
                } else {
                    last_token=yytokentype::TK_NEWLINE;
                    return yytokentype::TK_EOLCOMMENT;
                }
            }
#line 1139 "tokenizer.cpp"
yy82:
	yych = *++cur;
yy83:
	if (yybm[256+yych] & 128) {
		goto yy82;
	}
	if (yych <= 0x00) goto yy79;
	yyaccept = 3;
	yych = *(mar = ++cur);
	if (yych == '"') goto yy82;
yy85:
#line 607 "tokenizer.re"
	{ token_str(yylval.string); RET(TK_STRING) }
#line 1153 "tokenizer.cpp"
yy86:
	yych = *++cur;
yy87:
	if (yych <= 0x00) goto yy79;
	if (yych != '\n') goto yy86;
	++cur;
#line 601 "tokenizer.re"
	{ line_num++; cur_line=cur; continue; }
#line 1162 "tokenizer.cpp"
yy90:
	yych = *++cur;
yy91:
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy79;
			goto yy90;
		} else {
			if (yych <= '\n') goto yy92;
			if (yych <= '\v') goto yy90;
			goto yy79;
		}
	} else {
		if (yych <= 0x1F) {
			if (yych <= '\r') goto yy90;
			goto yy79;
		} else {
			if (yych <= ' ') goto yy90;
			if (yych <= '!') goto yy95;
			goto yy79;
		}
	}
yy92:
	yyaccept = 4;
	yych = *(mar = ++cur);
	if (yybm[0+yych] & 1) {
		goto yy92;
	}
	if (yych <= 0x1F) goto yy94;
	if (yych <= '!') goto yy95;
	if (yych == '&') goto yy222;
yy94:
#line 583 "tokenizer.re"
	{
                line_num++; cur_line=cur; continue;
            }
#line 1199 "tokenizer.cpp"
yy95:
	yych = *++cur;
	if (yych <= 0x00) goto yy79;
	if (yych == '\n') goto yy92;
	goto yy95;
yy97:
	yych = *++cur;
yy98:
	if (yybm[0+yych] & 2) {
		goto yy97;
	}
	if (yych <= 0x00) goto yy79;
	yyaccept = 5;
	yych = *(mar = ++cur);
	if (yych == '\'') goto yy97;
yy100:
#line 608 "tokenizer.re"
	{ token_str(yylval.string); RET(TK_STRING) }
#line 1218 "tokenizer.cpp"
yy101:
	yyaccept = 6;
	yych = *(mar = ++cur);
	if (yych <= 0x1F) {
		if (yych <= '\n') {
			if (yych == '\t') goto yy223;
			goto yy72;
		} else {
			if (yych == '\f') goto yy72;
			if (yych <= '\r') goto yy223;
			goto yy72;
		}
	} else {
		if (yych <= '.') {
			if (yych <= ' ') goto yy223;
			if (yych == ')') goto yy225;
			goto yy72;
		} else {
			if (yych <= '/') goto yy227;
			if (yych == '=') goto yy228;
			goto yy72;
		}
	}
yy102:
	++cur;
#line 503 "tokenizer.re"
	{ RET(TK_POW) }
#line 1246 "tokenizer.cpp"
yy104:
	++cur;
#line 501 "tokenizer.re"
	{ RET(TK_DBL_DOT) }
#line 1251 "tokenizer.cpp"
yy106:
	yyaccept = 7;
	yych = *(mar = ++cur);
yy107:
	if (yych <= 'E') {
		if (yych <= '/') goto yy108;
		if (yych <= '9') goto yy106;
		if (yych >= 'D') goto yy128;
	} else {
		if (yych <= '_') {
			if (yych >= '_') goto yy230;
		} else {
			if (yych <= 'c') goto yy108;
			if (yych <= 'e') goto yy128;
		}
	}
yy108:
#line 540 "tokenizer.re"
	{ token(yylval.string); RET(TK_REAL) }
#line 1271 "tokenizer.cpp"
yy109:
	yych = *++cur;
	if (yych == 'N') goto yy233;
	if (yych == 'n') goto yy233;
	goto yy111;
yy110:
	yych = *++cur;
yy111:
	if (yybm[0+yych] & 4) {
		goto yy110;
	}
	if (yych == '.') goto yy231;
	goto yy79;
yy112:
	yych = *++cur;
	if (yych == 'Q') goto yy234;
	if (yych == 'q') goto yy234;
	goto yy111;
yy113:
	yych = *++cur;
	if (yych == 'A') goto yy235;
	if (yych == 'a') goto yy235;
	goto yy111;
yy114:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych == 'E') goto yy236;
		if (yych <= 'S') goto yy111;
		goto yy237;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy111;
			goto yy236;
		} else {
			if (yych == 't') goto yy237;
			goto yy111;
		}
	}
yy115:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych == 'E') goto yy238;
		if (yych <= 'S') goto yy111;
		goto yy239;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy111;
			goto yy238;
		} else {
			if (yych == 't') goto yy239;
			goto yy111;
		}
	}
yy116:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'E') goto yy240;
		if (yych <= 'N') goto yy111;
		goto yy241;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy111;
			goto yy240;
		} else {
			if (yych == 'o') goto yy241;
			goto yy111;
		}
	}
yy117:
	yych = *++cur;
	if (yych == 'R') goto yy242;
	if (yych == 'r') goto yy242;
	goto yy111;
yy118:
	yych = *++cur;
	if (yych == 'R') goto yy243;
	if (yych == 'r') goto yy243;
	goto yy111;
yy119:
	++cur;
#line 488 "tokenizer.re"
	{ RET(TK_RBRACKET_OLD) }
#line 1354 "tokenizer.cpp"
yy121:
	++cur;
#line 504 "tokenizer.re"
	{ RET(TK_CONCAT) }
#line 1359 "tokenizer.cpp"
yy123:
	++cur;
#line 509 "tokenizer.re"
	{ RET(TK_NE) }
#line 1364 "tokenizer.cpp"
yy125:
	yych = *++cur;
	if (yych <= 0x1F) {
		if (yych <= '\n') {
			if (yych == '\t') goto yy125;
			goto yy79;
		} else {
			if (yych == '\f') goto yy79;
			if (yych <= '\r') goto yy125;
			goto yy79;
		}
	} else {
		if (yych <= '^') {
			if (yych <= ' ') goto yy125;
			if (yych <= '@') goto yy79;
			if (yych <= 'Z') goto yy244;
			goto yy79;
		} else {
			if (yych == '`') goto yy79;
			if (yych <= 'z') goto yy244;
			goto yy79;
		}
	}
yy127:
	yyaccept = 7;
	yych = *(mar = ++cur);
	if (yych <= 'Z') {
		if (yych <= '@') goto yy107;
		if (yych <= 'C') goto yy247;
		if (yych <= 'E') goto yy249;
		goto yy247;
	} else {
		if (yych <= 'c') {
			if (yych <= '`') goto yy107;
			goto yy247;
		} else {
			if (yych <= 'e') goto yy249;
			if (yych <= 'z') goto yy247;
			goto yy107;
		}
	}
yy128:
	yych = *++cur;
	if (yych <= ',') {
		if (yych == '+') goto yy250;
		goto yy79;
	} else {
		if (yych <= '-') goto yy250;
		if (yych <= '/') goto yy79;
		if (yych <= '9') goto yy251;
		goto yy79;
	}
yy129:
	yych = *++cur;
	if (yych <= '9') {
		if (yych <= '&') {
			if (yych == '"') goto yy82;
			goto yy79;
		} else {
			if (yych <= '\'') goto yy97;
			if (yych <= '/') goto yy79;
			goto yy253;
		}
	} else {
		if (yych <= '^') {
			if (yych <= '@') goto yy79;
			if (yych <= 'Z') goto yy255;
			goto yy79;
		} else {
			if (yych == '`') goto yy79;
			if (yych <= 'z') goto yy255;
			goto yy79;
		}
	}
yy130:
	++cur;
#line 502 "tokenizer.re"
	{ RET(TK_DBL_COLON) }
#line 1443 "tokenizer.cpp"
yy132:
	++cur;
#line 511 "tokenizer.re"
	{ RET(TK_LE) }
#line 1448 "tokenizer.cpp"
yy134:
	++cur;
#line 508 "tokenizer.re"
	{ RET(TK_EQ) }
#line 1453 "tokenizer.cpp"
yy136:
	++cur;
#line 505 "tokenizer.re"
	{ RET(TK_ARROW) }
#line 1458 "tokenizer.cpp"
yy138:
	++cur;
#line 513 "tokenizer.re"
	{ RET(TK_GE) }
#line 1463 "tokenizer.cpp"
yy140:
	yych = *++cur;
	if (yych == 'S') goto yy257;
	if (yych == 's') goto yy257;
	goto yy55;
yy141:
	yych = *++cur;
	if (yych == 'L') goto yy258;
	if (yych == 'l') goto yy258;
	goto yy55;
yy142:
	yych = *++cur;
	if (yych <= 'Y') {
		if (yych == 'S') goto yy260;
		if (yych <= 'X') goto yy55;
		goto yy261;
	} else {
		if (yych <= 's') {
			if (yych <= 'r') goto yy55;
			goto yy260;
		} else {
			if (yych == 'y') goto yy261;
			goto yy55;
		}
	}
yy143:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych <= '&') {
		if (yych == '"') goto yy82;
		goto yy47;
	} else {
		if (yych <= '\'') goto yy97;
		if (yych == '_') goto yy143;
		goto yy47;
	}
yy145:
	yych = *++cur;
	if (yybm[0+yych] & 32) {
		goto yy262;
	}
	goto yy79;
yy146:
	yych = *++cur;
	if (yych <= '/') goto yy79;
	if (yych <= '1') goto yy264;
	goto yy79;
yy147:
	yych = *++cur;
	if (yych == 'C') goto yy266;
	if (yych == 'c') goto yy266;
	goto yy55;
yy148:
	yych = *++cur;
	if (yych == 'N') goto yy267;
	if (yych == 'n') goto yy267;
	goto yy55;
yy149:
	yych = *++cur;
	if (yych == 'O') goto yy268;
	if (yych == 'o') goto yy268;
	goto yy55;
yy150:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych == 'L') goto yy269;
		if (yych <= 'R') goto yy55;
		goto yy270;
	} else {
		if (yych <= 'l') {
			if (yych <= 'k') goto yy55;
			goto yy269;
		} else {
			if (yych == 's') goto yy270;
			goto yy55;
		}
	}
yy151:
	yych = *++cur;
	if (yych == 'A') goto yy271;
	if (yych == 'a') goto yy271;
	goto yy55;
yy152:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'A') goto yy272;
		if (yych <= 'N') goto yy55;
		goto yy273;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy272;
		} else {
			if (yych == 'o') goto yy273;
			goto yy55;
		}
	}
yy153:
	yych = *++cur;
	if (yych <= 'N') {
		if (yych <= 'D') {
			if (yych <= 'C') goto yy55;
			goto yy274;
		} else {
			if (yych <= 'L') goto yy55;
			if (yych <= 'M') goto yy275;
			goto yy276;
		}
	} else {
		if (yych <= 'l') {
			if (yych == 'd') goto yy274;
			goto yy55;
		} else {
			if (yych <= 'm') goto yy275;
			if (yych <= 'n') goto yy276;
			goto yy55;
		}
	}
yy154:
	yych = *++cur;
	if (yych == 'I') goto yy277;
	if (yych == 'i') goto yy277;
	goto yy55;
yy155:
	yych = *++cur;
	if (yych == 'C') goto yy278;
	if (yych == 'c') goto yy278;
	goto yy55;
yy156:
	yych = *++cur;
	if (yych == 'T') goto yy279;
	if (yych == 't') goto yy279;
	goto yy55;
yy157:
	yych = *++cur;
	if (yych <= 'F') {
		if (yych == 'A') goto yy280;
		if (yych <= 'E') goto yy55;
		goto yy281;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy280;
		} else {
			if (yych == 'f') goto yy281;
			goto yy55;
		}
	}
yy158:
	yych = *++cur;
	if (yych == 'M') goto yy282;
	if (yych == 'm') goto yy282;
	goto yy55;
yy159:
	yyaccept = 8;
	yych = *(mar = ++cur);
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= '@') {
		if (yych <= '\f') {
			if (yych <= '\t') {
				if (yych >= '\t') {
					ctxmar = cur;
					goto yy283;
				}
			} else {
				if (yych == '\v') {
					ctxmar = cur;
					goto yy283;
				}
			}
		} else {
			if (yych <= ' ') {
				if (yych <= '\r') {
					ctxmar = cur;
					goto yy283;
				}
				if (yych >= ' ') {
					ctxmar = cur;
					goto yy283;
				}
			} else {
				if (yych <= '/') goto yy160;
				if (yych <= '9') goto yy54;
			}
		}
	} else {
		if (yych <= '`') {
			if (yych <= 'V') {
				if (yych == 'U') goto yy285;
				goto yy54;
			} else {
				if (yych <= 'W') goto yy286;
				if (yych <= 'Z') goto yy54;
			}
		} else {
			if (yych <= 'v') {
				if (yych == 'u') goto yy285;
				goto yy54;
			} else {
				if (yych <= 'w') goto yy286;
				if (yych <= 'z') goto yy54;
			}
		}
	}
yy160:
#line 265 "tokenizer.re"
	{ KW(DO) }
#line 1676 "tokenizer.cpp"
yy161:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych == 'E') goto yy287;
		if (yych <= 'R') goto yy55;
		goto yy288;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy287;
		} else {
			if (yych == 's') goto yy288;
			goto yy55;
		}
	}
yy162:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych <= 'D') {
			if (yych <= 'C') goto yy55;
			goto yy289;
		} else {
			if (yych <= 'S') goto yy55;
			if (yych <= 'T') goto yy291;
			goto yy292;
		}
	} else {
		if (yych <= 's') {
			if (yych == 'd') goto yy289;
			goto yy55;
		} else {
			if (yych <= 't') goto yy291;
			if (yych <= 'u') goto yy292;
			goto yy55;
		}
	}
yy163:
	yych = *++cur;
	if (yych == 'U') goto yy293;
	if (yych == 'u') goto yy293;
	goto yy55;
yy164:
	yych = *++cur;
	if (yych == 'R') goto yy294;
	if (yych == 'r') goto yy294;
	goto yy55;
yy165:
	yych = *++cur;
	if (yych == 'E') goto yy295;
	if (yych == 'e') goto yy295;
	goto yy55;
yy166:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych == 'I') goto yy296;
		if (yych <= 'S') goto yy55;
		goto yy297;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy55;
			goto yy296;
		} else {
			if (yych == 't') goto yy297;
			goto yy55;
		}
	}
yy167:
	yych = *++cur;
	if (yych <= 'N') {
		if (yych == 'L') goto yy298;
		if (yych <= 'M') goto yy55;
		goto yy299;
	} else {
		if (yych <= 'l') {
			if (yych <= 'k') goto yy55;
			goto yy298;
		} else {
			if (yych == 'n') goto yy299;
			goto yy55;
		}
	}
yy168:
	yych = *++cur;
	if (yych == 'U') goto yy300;
	if (yych == 'u') goto yy300;
	goto yy55;
yy169:
	yych = *++cur;
	if (yych == 'R') goto yy301;
	if (yych == 'r') goto yy301;
	goto yy55;
yy170:
	yych = *++cur;
	if (yych == 'N') goto yy302;
	if (yych == 'n') goto yy302;
	goto yy55;
yy171:
	yych = *++cur;
	if (yych == 'N') goto yy303;
	if (yych == 'n') goto yy303;
	goto yy55;
yy172:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'T') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy173;
			if (yych <= 'S') goto yy54;
			goto yy304;
		}
	} else {
		if (yych <= 's') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 't') goto yy304;
			if (yych <= 'z') goto yy54;
		}
	}
yy173:
#line 376 "tokenizer.re"
	{ KW(GO) }
#line 1803 "tokenizer.cpp"
yy174:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 378 "tokenizer.re"
	{ KW(IF) }
#line 1812 "tokenizer.cpp"
yy176:
	yych = *++cur;
	if (yych == 'P') goto yy305;
	if (yych == 'p') goto yy305;
	goto yy55;
yy177:
	yyaccept = 9;
	yych = *(mar = ++cur);
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'O') {
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych == '\t') goto yy306;
			} else {
				if (yych == '\f') goto yy178;
				if (yych <= '\r') goto yy306;
			}
		} else {
			if (yych <= '@') {
				if (yych <= ' ') goto yy306;
				if (yych <= '/') goto yy178;
				if (yych <= '9') goto yy54;
			} else {
				if (yych == 'C') goto yy308;
				if (yych <= 'N') goto yy54;
				goto yy309;
			}
		}
	} else {
		if (yych <= 'c') {
			if (yych <= 'T') {
				if (yych == 'Q') goto yy310;
				if (yych <= 'S') goto yy54;
				goto yy311;
			} else {
				if (yych <= 'Z') goto yy54;
				if (yych <= '`') goto yy178;
				if (yych <= 'b') goto yy54;
				goto yy308;
			}
		} else {
			if (yych <= 'q') {
				if (yych == 'o') goto yy309;
				if (yych <= 'p') goto yy54;
				goto yy310;
			} else {
				if (yych == 't') goto yy311;
				if (yych <= 'z') goto yy54;
			}
		}
	}
yy178:
#line 382 "tokenizer.re"
	{ KW(IN) }
#line 1869 "tokenizer.cpp"
yy179:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 391 "tokenizer.re"
	{ KW(IS) }
#line 1878 "tokenizer.cpp"
yy181:
	yych = *++cur;
	if (yych == 'N') goto yy312;
	if (yych == 'n') goto yy312;
	goto yy55;
yy182:
	yych = *++cur;
	if (yych == 'N') goto yy313;
	if (yych == 'n') goto yy313;
	goto yy55;
yy183:
	yych = *++cur;
	if (yych <= 'G') {
		if (yych == 'C') goto yy315;
		if (yych <= 'F') goto yy55;
		goto yy316;
	} else {
		if (yych <= 'c') {
			if (yych <= 'b') goto yy55;
			goto yy315;
		} else {
			if (yych == 'g') goto yy316;
			goto yy55;
		}
	}
yy184:
	yych = *++cur;
	if (yych <= 'L') {
		if (yych == 'D') goto yy317;
		if (yych <= 'K') goto yy55;
		goto yy318;
	} else {
		if (yych <= 'd') {
			if (yych <= 'c') goto yy55;
			goto yy317;
		} else {
			if (yych == 'l') goto yy318;
			goto yy55;
		}
	}
yy185:
	yych = *++cur;
	if (yych == 'M') goto yy319;
	if (yych == 'm') goto yy319;
	goto yy55;
yy186:
	yych = *++cur;
	if (yych <= 'P') {
		if (yych == 'N') goto yy320;
		if (yych <= 'O') goto yy55;
		goto yy321;
	} else {
		if (yych <= 'n') {
			if (yych <= 'm') goto yy55;
			goto yy320;
		} else {
			if (yych == 'p') goto yy321;
			goto yy55;
		}
	}
yy187:
	yych = *++cur;
	if (yych == 'L') goto yy322;
	if (yych == 'l') goto yy322;
	goto yy55;
yy188:
	yych = *++cur;
	if (yybm[0+yych] & 64) {
		goto yy323;
	}
	goto yy79;
yy189:
	yych = *++cur;
	if (yych <= '/') goto yy79;
	if (yych <= '7') goto yy325;
	goto yy79;
yy190:
	yych = *++cur;
	if (yych == 'L') goto yy327;
	if (yych == 'l') goto yy327;
	goto yy55;
yy191:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych == 'E') goto yy328;
		if (yych <= 'S') goto yy55;
		goto yy329;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy328;
		} else {
			if (yych == 't') goto yy329;
			goto yy55;
		}
	}
yy192:
	yych = *++cur;
	if (yych == 'T') goto yy330;
	if (yych == 't') goto yy330;
	goto yy55;
yy193:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych <= 'Q') goto yy55;
		if (yych <= 'R') goto yy332;
		goto yy333;
	} else {
		if (yych <= 'q') goto yy55;
		if (yych <= 'r') goto yy332;
		if (yych <= 's') goto yy333;
		goto yy55;
	}
yy194:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych == 'I') goto yy334;
		if (yych <= 'R') goto yy55;
		goto yy335;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy55;
			goto yy334;
		} else {
			if (yych == 's') goto yy335;
			goto yy55;
		}
	}
yy195:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych <= 'H') {
			if (yych == 'E') goto yy336;
			goto yy55;
		} else {
			if (yych <= 'I') goto yy337;
			if (yych <= 'N') goto yy55;
			goto yy338;
		}
	} else {
		if (yych <= 'h') {
			if (yych == 'e') goto yy336;
			goto yy55;
		} else {
			if (yych <= 'i') goto yy337;
			if (yych == 'o') goto yy338;
			goto yy55;
		}
	}
yy196:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'B') goto yy339;
		if (yych <= 'Q') goto yy55;
		goto yy340;
	} else {
		if (yych <= 'b') {
			if (yych <= 'a') goto yy55;
			goto yy339;
		} else {
			if (yych == 'r') goto yy340;
			goto yy55;
		}
	}
yy197:
	yych = *++cur;
	if (yych == 'I') goto yy341;
	if (yych == 'i') goto yy341;
	goto yy55;
yy198:
	yych = *++cur;
	if (yych == 'N') goto yy342;
	if (yych == 'n') goto yy342;
	goto yy55;
yy199:
	yych = *++cur;
	switch (yych) {
	case 'A':
	case 'a':	goto yy343;
	case 'C':
	case 'c':	goto yy344;
	case 'D':
	case 'd':	goto yy345;
	case 'S':
	case 's':	goto yy346;
	case 'T':
	case 't':	goto yy347;
	case 'W':
	case 'w':	goto yy348;
	default:	goto yy55;
	}
yy200:
	yych = *++cur;
	if (yych == 'V') goto yy349;
	if (yych == 'v') goto yy349;
	goto yy55;
yy201:
	yych = *++cur;
	if (yych <= 'Q') {
		if (yych == 'L') goto yy350;
		if (yych <= 'P') goto yy55;
		goto yy351;
	} else {
		if (yych <= 'l') {
			if (yych <= 'k') goto yy55;
			goto yy350;
		} else {
			if (yych == 'q') goto yy351;
			goto yy55;
		}
	}
yy202:
	yych = *++cur;
	if (yych == 'A') goto yy352;
	if (yych == 'a') goto yy352;
	goto yy55;
yy203:
	yych = *++cur;
	if (yych == 'U') goto yy353;
	if (yych == 'u') goto yy353;
	goto yy55;
yy204:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'A') goto yy354;
		if (yych <= 'N') goto yy55;
		goto yy355;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy354;
		} else {
			if (yych == 'o') goto yy355;
			goto yy55;
		}
	}
yy205:
	yych = *++cur;
	if (yych == 'B') goto yy356;
	if (yych == 'b') goto yy356;
	goto yy55;
yy206:
	yych = *++cur;
	if (yych == 'N') goto yy357;
	if (yych == 'n') goto yy357;
	goto yy55;
yy207:
	yych = *++cur;
	if (yych == 'R') goto yy358;
	if (yych == 'r') goto yy358;
	goto yy55;
yy208:
	yych = *++cur;
	if (yych == 'A') goto yy359;
	if (yych == 'a') goto yy359;
	goto yy55;
yy209:
	yych = *++cur;
	if (yych == 'E') goto yy360;
	if (yych == 'e') goto yy360;
	goto yy55;
yy210:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 450 "tokenizer.re"
	{ KW(TO) }
#line 2148 "tokenizer.cpp"
yy212:
	yych = *++cur;
	if (yych == 'P') goto yy361;
	if (yych == 'p') goto yy361;
	goto yy55;
yy213:
	yych = *++cur;
	if (yych == 'F') goto yy362;
	if (yych == 'f') goto yy362;
	goto yy55;
yy214:
	yych = *++cur;
	if (yych == 'E') goto yy363;
	if (yych == 'e') goto yy363;
	goto yy55;
yy215:
	yych = *++cur;
	if (yych == 'L') goto yy365;
	if (yych == 'l') goto yy365;
	goto yy55;
yy216:
	yych = *++cur;
	if (yych == 'L') goto yy366;
	if (yych == 'l') goto yy366;
	goto yy55;
yy217:
	yych = *++cur;
	if (yych == 'I') goto yy367;
	if (yych == 'i') goto yy367;
	goto yy55;
yy218:
	yych = *++cur;
	if (yych <= 'I') {
		if (yych == 'E') goto yy368;
		if (yych <= 'H') goto yy55;
		goto yy369;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy368;
		} else {
			if (yych == 'i') goto yy369;
			goto yy55;
		}
	}
yy219:
	yych = *++cur;
	if (yych == 'I') goto yy370;
	if (yych == 'i') goto yy370;
	goto yy55;
yy220:
	yych = *++cur;
	if (yych == '"') goto yy79;
	goto yy372;
yy221:
	yych = *++cur;
	if (yych == '\'') goto yy79;
	goto yy374;
yy222:
	++cur;
	goto yy94;
yy223:
	yych = *++cur;
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy79;
			goto yy223;
		} else {
			if (yych == '\v') goto yy223;
			goto yy79;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy223;
			if (yych <= 0x1F) goto yy79;
			goto yy223;
		} else {
			if (yych == ')') goto yy375;
			goto yy79;
		}
	}
yy225:
	++cur;
	cur -= 2;
#line 479 "tokenizer.re"
	{ RET(TK_LPAREN) }
#line 2235 "tokenizer.cpp"
yy227:
	yych = *++cur;
	if (yych == ')') goto yy379;
	goto yy378;
yy228:
	++cur;
	cur -= 2;
#line 478 "tokenizer.re"
	{ RET(TK_LPAREN) }
#line 2245 "tokenizer.cpp"
yy230:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy79;
		if (yych <= '9') goto yy381;
		if (yych <= '@') goto yy79;
		goto yy383;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy79;
			goto yy383;
		} else {
			if (yych <= '`') goto yy79;
			if (yych <= 'z') goto yy383;
			goto yy79;
		}
	}
yy231:
	++cur;
#line 610 "tokenizer.re"
	{ token(yylval.string); RET(TK_DEF_OP) }
#line 2267 "tokenizer.cpp"
yy233:
	yych = *++cur;
	if (yych == 'D') goto yy385;
	if (yych == 'd') goto yy385;
	goto yy111;
yy234:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych == '.') goto yy134;
		goto yy111;
	} else {
		if (yych <= 'V') goto yy386;
		if (yych == 'v') goto yy386;
		goto yy111;
	}
yy235:
	yych = *++cur;
	if (yych == 'L') goto yy387;
	if (yych == 'l') goto yy387;
	goto yy111;
yy236:
	yych = *++cur;
	if (yych == '.') goto yy138;
	goto yy111;
yy237:
	yych = *++cur;
	if (yych == '.') goto yy388;
	goto yy111;
yy238:
	yych = *++cur;
	if (yych == '.') goto yy132;
	goto yy111;
yy239:
	yych = *++cur;
	if (yych == '.') goto yy389;
	goto yy111;
yy240:
	yych = *++cur;
	if (yych <= 'P') {
		if (yych == '.') goto yy123;
		goto yy111;
	} else {
		if (yych <= 'Q') goto yy390;
		if (yych == 'q') goto yy390;
		goto yy111;
	}
yy241:
	yych = *++cur;
	if (yych == 'T') goto yy391;
	if (yych == 't') goto yy391;
	goto yy111;
yy242:
	yych = *++cur;
	if (yych == '.') goto yy392;
	goto yy111;
yy243:
	yych = *++cur;
	if (yych == 'U') goto yy394;
	if (yych == 'u') goto yy394;
	goto yy111;
yy244:
	yych = *++cur;
	if (yybm[0+yych] & 16) {
		goto yy244;
	}
	cur = ctxmar;
#line 541 "tokenizer.re"
	{
                if (last_token == yytokentype::TK_NEWLINE) {
                    uint64_t u;
                    if (lex_int(tok, cur, u, yylval.int_suffix.int_kind)) {
                            yylval.n = u;
                            if (enddo_label_stack[enddo_label_stack.size()-1] == u) {
                                while (enddo_label_stack[enddo_label_stack.size()-1] == u) {
                                    enddo_label_stack.pop_back();
                                    enddo_insert_count++;
                                }
                                enddo_newline_process = true;
                            } else {
                                enddo_newline_process = false;
                            }
                            RET(TK_LABEL)
                    } else {
                        token_loc(loc);
                        std::string t = token();
                        throw LFortran::TokenizerError("Integer too large",
                            loc, t);
                    }
                } else {
                    lex_int_large(al, tok, cur,
                        yylval.int_suffix.int_n,
                        yylval.int_suffix.int_kind);
                    RET(TK_INTEGER)
                }
            }
#line 2363 "tokenizer.cpp"
yy247:
	yych = *++cur;
yy248:
	if (yych <= '@') {
		if (yych == '.') goto yy395;
		goto yy79;
	} else {
		if (yych <= 'Z') goto yy247;
		if (yych <= '`') goto yy79;
		if (yych <= 'z') goto yy247;
		goto yy79;
	}
yy249:
	yych = *++cur;
	if (yych <= ',') {
		if (yych != '+') goto yy248;
	} else {
		if (yych <= '-') goto yy250;
		if (yych <= '/') goto yy248;
		if (yych <= '9') goto yy251;
		goto yy248;
	}
yy250:
	yych = *++cur;
	if (yych <= '/') goto yy79;
	if (yych >= ':') goto yy79;
yy251:
	yyaccept = 7;
	yych = *(mar = ++cur);
	if (yych <= '/') goto yy108;
	if (yych <= '9') goto yy251;
	if (yych == '_') goto yy230;
	goto yy108;
yy253:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych <= '\r') {
		if (yych <= '\n') {
			if (yych == '\t') {
				ctxmar = cur;
				goto yy125;
			}
			goto yy35;
		} else {
			if (yych == '\f') goto yy35;
			ctxmar = cur;
			goto yy125;
		}
	} else {
		if (yych <= '-') {
			if (yych == ' ') {
				ctxmar = cur;
				goto yy125;
			}
			goto yy35;
		} else {
			if (yych <= '.') {
				ctxmar = cur;
				goto yy397;
			}
			if (yych <= '/') goto yy35;
			if (yych <= '9') goto yy253;
			goto yy35;
		}
	}
yy255:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych <= '-') {
		if (yych <= '\v') {
			if (yych == '\t') {
				ctxmar = cur;
				goto yy125;
			}
			if (yych <= '\n') goto yy35;
			ctxmar = cur;
			goto yy125;
		} else {
			if (yych <= '\r') {
				if (yych <= '\f') goto yy35;
				ctxmar = cur;
				goto yy125;
			} else {
				if (yych == ' ') {
					ctxmar = cur;
					goto yy125;
				}
				goto yy35;
			}
		}
	} else {
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych <= '.') {
					ctxmar = cur;
					goto yy397;
				}
				goto yy35;
			} else {
				if (yych <= '9') goto yy255;
				if (yych <= '@') goto yy35;
				goto yy255;
			}
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy35;
				goto yy255;
			} else {
				if (yych <= '`') goto yy35;
				if (yych <= 'z') goto yy255;
				goto yy35;
			}
		}
	}
yy257:
	yych = *++cur;
	if (yych == 'T') goto yy398;
	if (yych == 't') goto yy398;
	goto yy55;
yy258:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'O') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy259;
			if (yych <= 'N') goto yy54;
			goto yy399;
		}
	} else {
		if (yych <= 'n') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 'o') goto yy399;
			if (yych <= 'z') goto yy54;
		}
	}
yy259:
#line 229 "tokenizer.re"
	{ KW(ALL) }
#line 2508 "tokenizer.cpp"
yy260:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'I') goto yy400;
		if (yych <= 'N') goto yy55;
		goto yy401;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy55;
			goto yy400;
		} else {
			if (yych == 'o') goto yy401;
			goto yy55;
		}
	}
yy261:
	yych = *++cur;
	if (yych == 'N') goto yy402;
	if (yych == 'n') goto yy402;
	goto yy55;
yy262:
	yych = *++cur;
	if (yybm[0+yych] & 32) {
		goto yy262;
	}
	if (yych == '"') goto yy403;
	goto yy79;
yy264:
	yych = *++cur;
	if (yych == '\'') goto yy405;
	if (yych <= '/') goto yy79;
	if (yych <= '1') goto yy264;
	goto yy79;
yy266:
	yych = *++cur;
	if (yych == 'K') goto yy407;
	if (yych == 'k') goto yy407;
	goto yy55;
yy267:
	yych = *++cur;
	if (yych == 'D') goto yy408;
	if (yych == 'd') goto yy408;
	goto yy55;
yy268:
	yych = *++cur;
	if (yych == 'C') goto yy410;
	if (yych == 'c') goto yy410;
	goto yy55;
yy269:
	yych = *++cur;
	if (yych == 'L') goto yy411;
	if (yych == 'l') goto yy411;
	goto yy55;
yy270:
	yych = *++cur;
	if (yych == 'E') goto yy413;
	if (yych == 'e') goto yy413;
	goto yy55;
yy271:
	yych = *++cur;
	if (yych == 'R') goto yy415;
	if (yych == 'r') goto yy415;
	goto yy55;
yy272:
	yych = *++cur;
	if (yych == 'S') goto yy416;
	if (yych == 's') goto yy416;
	goto yy55;
yy273:
	yych = *++cur;
	if (yych == 'S') goto yy417;
	if (yych == 's') goto yy417;
	goto yy55;
yy274:
	yych = *++cur;
	if (yych == 'I') goto yy418;
	if (yych == 'i') goto yy418;
	goto yy55;
yy275:
	yych = *++cur;
	if (yych <= 'P') {
		if (yych == 'M') goto yy419;
		if (yych <= 'O') goto yy55;
		goto yy420;
	} else {
		if (yych <= 'm') {
			if (yych <= 'l') goto yy55;
			goto yy419;
		} else {
			if (yych == 'p') goto yy420;
			goto yy55;
		}
	}
yy276:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych == 'C') goto yy421;
		if (yych <= 'S') goto yy55;
		goto yy422;
	} else {
		if (yych <= 'c') {
			if (yych <= 'b') goto yy55;
			goto yy421;
		} else {
			if (yych == 't') goto yy422;
			goto yy55;
		}
	}
yy277:
	yych = *++cur;
	if (yych == 'T') goto yy423;
	if (yych == 't') goto yy423;
	goto yy55;
yy278:
	yych = *++cur;
	if (yych == 'L') goto yy424;
	if (yych == 'l') goto yy424;
	goto yy55;
yy279:
	yych = *++cur;
	if (yych == 'A') goto yy425;
	if (yych == 'a') goto yy425;
	goto yy55;
yy280:
	yych = *++cur;
	if (yych == 'L') goto yy427;
	if (yych == 'l') goto yy427;
	goto yy55;
yy281:
	yych = *++cur;
	if (yych <= 'E') {
		if (yych == 'A') goto yy428;
		if (yych <= 'D') goto yy55;
		goto yy429;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy428;
		} else {
			if (yych == 'e') goto yy429;
			goto yy55;
		}
	}
yy282:
	yych = *++cur;
	if (yych == 'E') goto yy430;
	if (yych == 'e') goto yy430;
	goto yy55;
yy283:
	yych = *++cur;
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy79;
			goto yy283;
		} else {
			if (yych == '\v') goto yy283;
			goto yy79;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy283;
			if (yych <= 0x1F) goto yy79;
			goto yy283;
		} else {
			if (yych <= '/') goto yy79;
			if (yych <= '9') goto yy431;
			goto yy79;
		}
	}
yy285:
	yych = *++cur;
	if (yych == 'B') goto yy434;
	if (yych == 'b') goto yy434;
	goto yy55;
yy286:
	yych = *++cur;
	if (yych == 'H') goto yy435;
	if (yych == 'h') goto yy435;
	goto yy55;
yy287:
	yych = *++cur;
	if (yych == 'M') goto yy436;
	if (yych == 'm') goto yy436;
	goto yy55;
yy288:
	yych = *++cur;
	if (yych == 'E') goto yy437;
	if (yych == 'e') goto yy437;
	goto yy55;
yy289:
	yyaccept = 10;
	yych = *(mar = ++cur);
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	switch (yych) {
	case '\t':
	case '\v':
	case '\r':	goto yy439;
	case ' ':	goto yy441;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'G':
	case 'H':
	case 'J':
	case 'K':
	case 'L':
	case 'N':
	case 'O':
	case 'Q':
	case 'R':
	case 'U':
	case 'V':
	case 'X':
	case 'Y':
	case 'Z':
	case 'g':
	case 'h':
	case 'j':
	case 'k':
	case 'l':
	case 'n':
	case 'o':
	case 'q':
	case 'r':
	case 'u':
	case 'v':
	case 'x':
	case 'y':
	case 'z':	goto yy54;
	case 'A':
	case 'a':	goto yy442;
	case 'B':
	case 'b':	goto yy443;
	case 'C':
	case 'c':	goto yy444;
	case 'D':
	case 'd':	goto yy445;
	case 'E':
	case 'e':	goto yy446;
	case 'F':
	case 'f':	goto yy447;
	case 'I':
	case 'i':	goto yy448;
	case 'M':
	case 'm':	goto yy449;
	case 'P':
	case 'p':	goto yy450;
	case 'S':
	case 's':	goto yy451;
	case 'T':
	case 't':	goto yy452;
	case 'W':
	case 'w':	goto yy453;
	default:	goto yy290;
	}
yy290:
#line 274 "tokenizer.re"
	{ KW(END) }
#line 2776 "tokenizer.cpp"
yy291:
	yych = *++cur;
	if (yych == 'R') goto yy454;
	if (yych == 'r') goto yy454;
	goto yy55;
yy292:
	yych = *++cur;
	if (yych == 'M') goto yy455;
	if (yych == 'm') goto yy455;
	goto yy55;
yy293:
	yych = *++cur;
	if (yych == 'I') goto yy457;
	if (yych == 'i') goto yy457;
	goto yy55;
yy294:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'M') goto yy458;
		if (yych <= 'N') goto yy55;
		goto yy459;
	} else {
		if (yych <= 'm') {
			if (yych <= 'l') goto yy55;
			goto yy458;
		} else {
			if (yych == 'o') goto yy459;
			goto yy55;
		}
	}
yy295:
	yych = *++cur;
	if (yych == 'N') goto yy460;
	if (yych == 'n') goto yy460;
	goto yy55;
yy296:
	yych = *++cur;
	if (yych == 'T') goto yy461;
	if (yych == 't') goto yy461;
	goto yy55;
yy297:
	yych = *++cur;
	if (yych == 'E') goto yy463;
	if (yych == 'e') goto yy463;
	goto yy55;
yy298:
	yych = *++cur;
	if (yych == 'E') goto yy464;
	if (yych == 'e') goto yy464;
	goto yy55;
yy299:
	yych = *++cur;
	if (yych == 'A') goto yy466;
	if (yych == 'a') goto yy466;
	goto yy55;
yy300:
	yych = *++cur;
	if (yych == 'S') goto yy467;
	if (yych == 's') goto yy467;
	goto yy55;
yy301:
	yych = *++cur;
	if (yych <= 'M') {
		if (yych == 'A') goto yy468;
		if (yych <= 'L') goto yy55;
		goto yy469;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy468;
		} else {
			if (yych == 'm') goto yy469;
			goto yy55;
		}
	}
yy302:
	yych = *++cur;
	if (yych == 'C') goto yy470;
	if (yych == 'c') goto yy470;
	goto yy55;
yy303:
	yych = *++cur;
	if (yych == 'E') goto yy471;
	if (yych == 'e') goto yy471;
	goto yy55;
yy304:
	yych = *++cur;
	if (yych == 'O') goto yy472;
	if (yych == 'o') goto yy472;
	goto yy55;
yy305:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych <= 'N') {
			if (yych == 'L') goto yy474;
			goto yy55;
		} else {
			if (yych <= 'O') goto yy475;
			if (yych <= 'T') goto yy55;
			goto yy476;
		}
	} else {
		if (yych <= 'n') {
			if (yych == 'l') goto yy474;
			goto yy55;
		} else {
			if (yych <= 'o') goto yy475;
			if (yych == 'u') goto yy476;
			goto yy55;
		}
	}
yy306:
	yych = *++cur;
	if (yych <= '\r') {
		if (yych <= '\n') {
			if (yych == '\t') goto yy306;
			goto yy79;
		} else {
			if (yych == '\f') goto yy79;
			goto yy306;
		}
	} else {
		if (yych <= 'N') {
			if (yych == ' ') goto yy306;
			goto yy79;
		} else {
			if (yych <= 'O') goto yy477;
			if (yych == 'o') goto yy477;
			goto yy79;
		}
	}
yy308:
	yych = *++cur;
	if (yych == 'L') goto yy478;
	if (yych == 'l') goto yy478;
	goto yy55;
yy309:
	yych = *++cur;
	if (yych == 'U') goto yy479;
	if (yych == 'u') goto yy479;
	goto yy55;
yy310:
	yych = *++cur;
	if (yych == 'U') goto yy480;
	if (yych == 'u') goto yy480;
	goto yy55;
yy311:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'E') goto yy481;
		if (yych <= 'Q') goto yy55;
		goto yy482;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy481;
		} else {
			if (yych == 'r') goto yy482;
			goto yy55;
		}
	}
yy312:
	yych = *++cur;
	if (yych == 'D') goto yy483;
	if (yych == 'd') goto yy483;
	goto yy55;
yy313:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 393 "tokenizer.re"
	{ KW(LEN) }
#line 2951 "tokenizer.cpp"
yy315:
	yych = *++cur;
	if (yych == 'A') goto yy485;
	if (yych == 'a') goto yy485;
	goto yy55;
yy316:
	yych = *++cur;
	if (yych == 'I') goto yy486;
	if (yych == 'i') goto yy486;
	goto yy55;
yy317:
	yych = *++cur;
	if (yych == 'U') goto yy487;
	if (yych == 'u') goto yy487;
	goto yy55;
yy318:
	yych = *++cur;
	if (yych == 'D') goto yy488;
	if (yych == 'd') goto yy488;
	goto yy55;
yy319:
	yych = *++cur;
	if (yych == 'E') goto yy490;
	if (yych == 'e') goto yy490;
	goto yy55;
yy320:
	yych = *++cur;
	if (yych <= '^') {
		if (yych == 'E') goto yy492;
		goto yy55;
	} else {
		if (yych <= '_') goto yy494;
		if (yych == 'e') goto yy492;
		goto yy55;
	}
yy321:
	yych = *++cur;
	if (yych == 'A') goto yy495;
	if (yych == 'a') goto yy495;
	goto yy55;
yy322:
	yych = *++cur;
	if (yych == 'L') goto yy496;
	if (yych == 'l') goto yy496;
	goto yy55;
yy323:
	yych = *++cur;
	if (yybm[0+yych] & 64) {
		goto yy323;
	}
	if (yych == '"') goto yy497;
	goto yy79;
yy325:
	yych = *++cur;
	if (yych == '\'') goto yy499;
	if (yych <= '/') goto yy79;
	if (yych <= '7') goto yy325;
	goto yy79;
yy327:
	yych = *++cur;
	if (yych == 'Y') goto yy501;
	if (yych == 'y') goto yy501;
	goto yy55;
yy328:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'N') goto yy503;
		if (yych <= 'Q') goto yy55;
		goto yy505;
	} else {
		if (yych <= 'n') {
			if (yych <= 'm') goto yy55;
			goto yy503;
		} else {
			if (yych == 'r') goto yy505;
			goto yy55;
		}
	}
yy329:
	yych = *++cur;
	if (yych == 'I') goto yy506;
	if (yych == 'i') goto yy506;
	goto yy55;
yy330:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 411 "tokenizer.re"
	{ KW(OUT) }
#line 3043 "tokenizer.cpp"
yy332:
	yych = *++cur;
	if (yych == 'A') goto yy507;
	if (yych == 'a') goto yy507;
	goto yy55;
yy333:
	yych = *++cur;
	if (yych == 'S') goto yy508;
	if (yych == 's') goto yy508;
	goto yy55;
yy334:
	yych = *++cur;
	if (yych == 'N') goto yy510;
	if (yych == 'n') goto yy510;
	goto yy55;
yy335:
	yych = *++cur;
	if (yych == 'T') goto yy511;
	if (yych == 't') goto yy511;
	goto yy55;
yy336:
	yych = *++cur;
	if (yych == 'C') goto yy513;
	if (yych == 'c') goto yy513;
	goto yy55;
yy337:
	yych = *++cur;
	if (yych <= 'V') {
		if (yych == 'N') goto yy514;
		if (yych <= 'U') goto yy55;
		goto yy515;
	} else {
		if (yych <= 'n') {
			if (yych <= 'm') goto yy55;
			goto yy514;
		} else {
			if (yych == 'v') goto yy515;
			goto yy55;
		}
	}
yy338:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych <= 'F') {
			if (yych == 'C') goto yy516;
			goto yy55;
		} else {
			if (yych <= 'G') goto yy517;
			if (yych <= 'S') goto yy55;
			goto yy518;
		}
	} else {
		if (yych <= 'f') {
			if (yych == 'c') goto yy516;
			goto yy55;
		} else {
			if (yych <= 'g') goto yy517;
			if (yych == 't') goto yy518;
			goto yy55;
		}
	}
yy339:
	yych = *++cur;
	if (yych == 'L') goto yy519;
	if (yych == 'l') goto yy519;
	goto yy55;
yy340:
	yych = *++cur;
	if (yych == 'E') goto yy520;
	if (yych == 'e') goto yy520;
	goto yy55;
yy341:
	yych = *++cur;
	if (yych == 'E') goto yy522;
	if (yych == 'e') goto yy522;
	goto yy55;
yy342:
	yych = *++cur;
	if (yych == 'K') goto yy523;
	if (yych == 'k') goto yy523;
	goto yy55;
yy343:
	yych = *++cur;
	if (yych <= 'L') {
		if (yych == 'D') goto yy525;
		if (yych <= 'K') goto yy55;
		goto yy527;
	} else {
		if (yych <= 'd') {
			if (yych <= 'c') goto yy55;
			goto yy525;
		} else {
			if (yych == 'l') goto yy527;
			goto yy55;
		}
	}
yy344:
	yych = *++cur;
	if (yych == 'U') goto yy529;
	if (yych == 'u') goto yy529;
	goto yy55;
yy345:
	yych = *++cur;
	if (yych == 'U') goto yy530;
	if (yych == 'u') goto yy530;
	goto yy55;
yy346:
	yych = *++cur;
	if (yych == 'U') goto yy531;
	if (yych == 'u') goto yy531;
	goto yy55;
yy347:
	yych = *++cur;
	if (yych == 'U') goto yy532;
	if (yych == 'u') goto yy532;
	goto yy55;
yy348:
	yych = *++cur;
	if (yych == 'I') goto yy533;
	if (yych == 'i') goto yy533;
	goto yy55;
yy349:
	yych = *++cur;
	if (yych == 'E') goto yy534;
	if (yych == 'e') goto yy534;
	goto yy55;
yy350:
	yych = *++cur;
	if (yych == 'E') goto yy536;
	if (yych == 'e') goto yy536;
	goto yy55;
yy351:
	yych = *++cur;
	if (yych == 'U') goto yy537;
	if (yych == 'u') goto yy537;
	goto yy55;
yy352:
	yych = *++cur;
	if (yych == 'R') goto yy538;
	if (yych == 'r') goto yy538;
	goto yy55;
yy353:
	yych = *++cur;
	if (yych == 'R') goto yy539;
	if (yych == 'r') goto yy539;
	goto yy55;
yy354:
	yych = *++cur;
	if (yych == 'T') goto yy540;
	if (yych == 't') goto yy540;
	goto yy55;
yy355:
	yych = *++cur;
	if (yych == 'P') goto yy542;
	if (yych == 'p') goto yy542;
	goto yy55;
yy356:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'M') goto yy544;
		if (yych <= 'Q') goto yy55;
		goto yy545;
	} else {
		if (yych <= 'm') {
			if (yych <= 'l') goto yy55;
			goto yy544;
		} else {
			if (yych == 'r') goto yy545;
			goto yy55;
		}
	}
yy357:
	yych = *++cur;
	if (yych == 'C') goto yy546;
	if (yych == 'c') goto yy546;
	goto yy55;
yy358:
	yych = *++cur;
	if (yych == 'G') goto yy548;
	if (yych == 'g') goto yy548;
	goto yy55;
yy359:
	yych = *++cur;
	if (yych == 'M') goto yy549;
	if (yych == 'm') goto yy549;
	goto yy55;
yy360:
	yych = *++cur;
	if (yych == 'N') goto yy551;
	if (yych == 'n') goto yy551;
	goto yy55;
yy361:
	yych = *++cur;
	if (yych == 'E') goto yy553;
	if (yych == 'e') goto yy553;
	goto yy55;
yy362:
	yych = *++cur;
	if (yych == 'O') goto yy555;
	if (yych == 'o') goto yy555;
	goto yy55;
yy363:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 453 "tokenizer.re"
	{ KW(USE) }
#line 3253 "tokenizer.cpp"
yy365:
	yych = *++cur;
	if (yych == 'U') goto yy556;
	if (yych == 'u') goto yy556;
	goto yy55;
yy366:
	yych = *++cur;
	if (yych == 'A') goto yy557;
	if (yych == 'a') goto yy557;
	goto yy55;
yy367:
	yych = *++cur;
	if (yych == 'T') goto yy558;
	if (yych == 't') goto yy558;
	goto yy55;
yy368:
	yych = *++cur;
	if (yych == 'R') goto yy560;
	if (yych == 'r') goto yy560;
	goto yy55;
yy369:
	yych = *++cur;
	if (yych == 'L') goto yy561;
	if (yych == 'l') goto yy561;
	goto yy55;
yy370:
	yych = *++cur;
	if (yych == 'T') goto yy562;
	if (yych == 't') goto yy562;
	goto yy55;
yy371:
	yych = *++cur;
yy372:
	if (yybm[0+yych] & 128) {
		goto yy371;
	}
	if (yych == '"') goto yy563;
	goto yy79;
yy373:
	yych = *++cur;
yy374:
	if (yych <= '9') {
		if (yych == '\'') goto yy565;
		if (yych <= '/') goto yy79;
		goto yy373;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy79;
			goto yy373;
		} else {
			if (yych <= '`') goto yy79;
			if (yych <= 'f') goto yy373;
			goto yy79;
		}
	}
yy375:
	++cur;
	cur = ctxmar;
#line 481 "tokenizer.re"
	{ RET(TK_LPAREN) }
#line 3314 "tokenizer.cpp"
yy377:
	yych = *++cur;
yy378:
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy79;
			goto yy377;
		} else {
			if (yych == '\v') goto yy377;
			goto yy79;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy377;
			if (yych <= 0x1F) goto yy79;
			goto yy377;
		} else {
			if (yych == ')') goto yy567;
			goto yy79;
		}
	}
yy379:
	++cur;
	cur -= 3;
#line 484 "tokenizer.re"
	{ RET(TK_LPAREN) }
#line 3341 "tokenizer.cpp"
yy381:
	yych = *++cur;
	if (yych <= '/') goto yy108;
	if (yych <= '9') goto yy381;
	goto yy108;
yy383:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy108;
		if (yych <= '9') goto yy383;
		if (yych <= '@') goto yy108;
		goto yy383;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy108;
			goto yy383;
		} else {
			if (yych <= '`') goto yy108;
			if (yych <= 'z') goto yy383;
			goto yy108;
		}
	}
yy385:
	yych = *++cur;
	if (yych == '.') goto yy569;
	goto yy111;
yy386:
	yych = *++cur;
	if (yych == '.') goto yy571;
	goto yy111;
yy387:
	yych = *++cur;
	if (yych == 'S') goto yy573;
	if (yych == 's') goto yy573;
	goto yy111;
yy388:
	++cur;
	goto yy45;
yy389:
	++cur;
	goto yy41;
yy390:
	yych = *++cur;
	if (yych == 'V') goto yy574;
	if (yych == 'v') goto yy574;
	goto yy111;
yy391:
	yych = *++cur;
	if (yych == '.') goto yy575;
	goto yy111;
yy392:
	++cur;
#line 518 "tokenizer.re"
	{ RET(TK_OR) }
#line 3396 "tokenizer.cpp"
yy394:
	yych = *++cur;
	if (yych == 'E') goto yy577;
	if (yych == 'e') goto yy577;
	goto yy111;
yy395:
	++cur;
	cur = ctxmar;
#line 532 "tokenizer.re"
	{
                lex_int_large(al, tok, cur,
                    yylval.int_suffix.int_n,
                    yylval.int_suffix.int_kind);
                RET(TK_INTEGER)
            }
#line 3412 "tokenizer.cpp"
yy397:
	yych = *++cur;
	if (yych == '.') goto yy79;
	goto yy248;
yy398:
	yych = *++cur;
	if (yych == 'R') goto yy578;
	if (yych == 'r') goto yy578;
	goto yy55;
yy399:
	yych = *++cur;
	if (yych == 'C') goto yy579;
	if (yych == 'c') goto yy579;
	goto yy55;
yy400:
	yych = *++cur;
	if (yych == 'G') goto yy580;
	if (yych == 'g') goto yy580;
	goto yy55;
yy401:
	yych = *++cur;
	if (yych == 'C') goto yy581;
	if (yych == 'c') goto yy581;
	goto yy55;
yy402:
	yych = *++cur;
	if (yych == 'C') goto yy582;
	if (yych == 'c') goto yy582;
	goto yy55;
yy403:
	++cur;
#line 576 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 3446 "tokenizer.cpp"
yy405:
	++cur;
#line 577 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 3451 "tokenizer.cpp"
yy407:
	yych = *++cur;
	if (yych == 'S') goto yy583;
	if (yych == 's') goto yy583;
	goto yy55;
yy408:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 237 "tokenizer.re"
	{ KW(BIND) }
#line 3465 "tokenizer.cpp"
yy410:
	yych = *++cur;
	if (yych == 'K') goto yy584;
	if (yych == 'k') goto yy584;
	goto yy55;
yy411:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 239 "tokenizer.re"
	{ KW(CALL) }
#line 3479 "tokenizer.cpp"
yy413:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 240 "tokenizer.re"
	{ KW(CASE) }
#line 3488 "tokenizer.cpp"
yy415:
	yych = *++cur;
	if (yych == 'A') goto yy586;
	if (yych == 'a') goto yy586;
	goto yy55;
yy416:
	yych = *++cur;
	if (yych == 'S') goto yy587;
	if (yych == 's') goto yy587;
	goto yy55;
yy417:
	yych = *++cur;
	if (yych == 'E') goto yy589;
	if (yych == 'e') goto yy589;
	goto yy55;
yy418:
	yych = *++cur;
	if (yych == 'M') goto yy591;
	if (yych == 'm') goto yy591;
	goto yy55;
yy419:
	yych = *++cur;
	if (yych == 'O') goto yy592;
	if (yych == 'o') goto yy592;
	goto yy55;
yy420:
	yych = *++cur;
	if (yych == 'L') goto yy593;
	if (yych == 'l') goto yy593;
	goto yy55;
yy421:
	yych = *++cur;
	if (yych == 'U') goto yy594;
	if (yych == 'u') goto yy594;
	goto yy55;
yy422:
	yych = *++cur;
	if (yych <= 'I') {
		if (yych == 'A') goto yy595;
		if (yych <= 'H') goto yy55;
		goto yy596;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy595;
		} else {
			if (yych == 'i') goto yy596;
			goto yy55;
		}
	}
yy423:
	yych = *++cur;
	if (yych == 'I') goto yy597;
	if (yych == 'i') goto yy597;
	goto yy55;
yy424:
	yych = *++cur;
	if (yych == 'E') goto yy598;
	if (yych == 'e') goto yy598;
	goto yy55;
yy425:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 253 "tokenizer.re"
	{ KW(DATA) }
#line 3557 "tokenizer.cpp"
yy427:
	yych = *++cur;
	if (yych == 'L') goto yy600;
	if (yych == 'l') goto yy600;
	goto yy55;
yy428:
	yych = *++cur;
	if (yych == 'U') goto yy601;
	if (yych == 'u') goto yy601;
	goto yy55;
yy429:
	yych = *++cur;
	if (yych == 'R') goto yy602;
	if (yych == 'r') goto yy602;
	goto yy55;
yy430:
	yych = *++cur;
	if (yych == 'N') goto yy603;
	if (yych == 'n') goto yy603;
	goto yy55;
yy431:
	yych = *++cur;
	if (yych <= '/') goto yy433;
	if (yych <= '9') goto yy431;
yy433:
	cur = ctxmar;
#line 258 "tokenizer.re"
	{
                // This is a label do statement, we have to match the
                // corresponding continue base "end do".
                uint64_t n = parse_int(cur);
                enddo_label_stack.push_back(n);
                KW(DO);
            }
#line 3592 "tokenizer.cpp"
yy434:
	yych = *++cur;
	if (yych == 'L') goto yy604;
	if (yych == 'l') goto yy604;
	goto yy55;
yy435:
	yych = *++cur;
	if (yych == 'I') goto yy605;
	if (yych == 'i') goto yy605;
	goto yy55;
yy436:
	yych = *++cur;
	if (yych == 'E') goto yy606;
	if (yych == 'e') goto yy606;
	goto yy55;
yy437:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'W') {
		if (yych <= '@') {
			if (yych <= '/') goto yy438;
			if (yych <= '9') goto yy54;
		} else {
			if (yych == 'I') goto yy607;
			if (yych <= 'V') goto yy54;
			goto yy608;
		}
	} else {
		if (yych <= 'i') {
			if (yych <= 'Z') goto yy54;
			if (yych <= '`') goto yy438;
			if (yych <= 'h') goto yy54;
			goto yy607;
		} else {
			if (yych == 'w') goto yy608;
			if (yych <= 'z') goto yy54;
		}
	}
yy438:
#line 270 "tokenizer.re"
	{ KW(ELSE) }
#line 3636 "tokenizer.cpp"
yy439:
	yych = *++cur;
yy440:
	switch (yych) {
	case '\t':
	case '\v':
	case '\r':
	case ' ':	goto yy439;
	case 'A':
	case 'a':	goto yy609;
	case 'B':
	case 'b':	goto yy610;
	case 'C':
	case 'c':	goto yy611;
	case 'D':
	case 'd':	goto yy612;
	case 'E':
	case 'e':	goto yy613;
	case 'F':
	case 'f':	goto yy614;
	case 'I':
	case 'i':	goto yy615;
	case 'M':
	case 'm':	goto yy616;
	case 'P':
	case 'p':	goto yy617;
	case 'S':
	case 's':	goto yy618;
	case 'T':
	case 't':	goto yy619;
	case 'W':
	case 'w':	goto yy620;
	default:	goto yy79;
	}
yy441:
	yych = *++cur;
	if (yych == 'F') goto yy621;
	if (yych == 'f') goto yy621;
	goto yy440;
yy442:
	yych = *++cur;
	if (yych == 'S') goto yy622;
	if (yych == 's') goto yy622;
	goto yy55;
yy443:
	yych = *++cur;
	if (yych == 'L') goto yy623;
	if (yych == 'l') goto yy623;
	goto yy55;
yy444:
	yych = *++cur;
	if (yych == 'R') goto yy624;
	if (yych == 'r') goto yy624;
	goto yy55;
yy445:
	yych = *++cur;
	if (yych == 'O') goto yy625;
	if (yych == 'o') goto yy625;
	goto yy55;
yy446:
	yych = *++cur;
	if (yych == 'N') goto yy627;
	if (yych == 'n') goto yy627;
	goto yy55;
yy447:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych <= 'N') {
			if (yych == 'I') goto yy628;
			goto yy55;
		} else {
			if (yych <= 'O') goto yy629;
			if (yych <= 'T') goto yy55;
			goto yy630;
		}
	} else {
		if (yych <= 'n') {
			if (yych == 'i') goto yy628;
			goto yy55;
		} else {
			if (yych <= 'o') goto yy629;
			if (yych == 'u') goto yy630;
			goto yy55;
		}
	}
yy448:
	yych = *++cur;
	if (yych <= 'N') {
		if (yych == 'F') goto yy631;
		if (yych <= 'M') goto yy55;
		goto yy633;
	} else {
		if (yych <= 'f') {
			if (yych <= 'e') goto yy55;
			goto yy631;
		} else {
			if (yych == 'n') goto yy633;
			goto yy55;
		}
	}
yy449:
	yych = *++cur;
	if (yych == 'O') goto yy634;
	if (yych == 'o') goto yy634;
	goto yy55;
yy450:
	yych = *++cur;
	if (yych == 'R') goto yy635;
	if (yych == 'r') goto yy635;
	goto yy55;
yy451:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych == 'E') goto yy636;
		if (yych <= 'T') goto yy55;
		goto yy637;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy636;
		} else {
			if (yych == 'u') goto yy637;
			goto yy55;
		}
	}
yy452:
	yych = *++cur;
	if (yych == 'Y') goto yy638;
	if (yych == 'y') goto yy638;
	goto yy55;
yy453:
	yych = *++cur;
	if (yych == 'H') goto yy639;
	if (yych == 'h') goto yy639;
	goto yy55;
yy454:
	yych = *++cur;
	if (yych == 'Y') goto yy640;
	if (yych == 'y') goto yy640;
	goto yy55;
yy455:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'E') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy456;
			if (yych <= 'D') goto yy54;
			goto yy642;
		}
	} else {
		if (yych <= 'd') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 'e') goto yy642;
			if (yych <= 'z') goto yy54;
		}
	}
yy456:
#line 348 "tokenizer.re"
	{ KW(ENUM) }
#line 3802 "tokenizer.cpp"
yy457:
	yych = *++cur;
	if (yych == 'V') goto yy643;
	if (yych == 'v') goto yy643;
	goto yy55;
yy458:
	yych = *++cur;
	if (yych == 'S') goto yy644;
	if (yych == 's') goto yy644;
	goto yy55;
yy459:
	yych = *++cur;
	if (yych == 'R') goto yy645;
	if (yych == 'r') goto yy645;
	goto yy55;
yy460:
	yych = *++cur;
	if (yych == 'T') goto yy647;
	if (yych == 't') goto yy647;
	goto yy55;
yy461:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 354 "tokenizer.re"
	{ KW(EXIT) }
#line 3831 "tokenizer.cpp"
yy463:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'N') goto yy649;
		if (yych <= 'Q') goto yy55;
		goto yy650;
	} else {
		if (yych <= 'n') {
			if (yych <= 'm') goto yy55;
			goto yy649;
		} else {
			if (yych == 'r') goto yy650;
			goto yy55;
		}
	}
yy464:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 357 "tokenizer.re"
	{ KW(FILE) }
#line 3855 "tokenizer.cpp"
yy466:
	yych = *++cur;
	if (yych == 'L') goto yy651;
	if (yych == 'l') goto yy651;
	goto yy55;
yy467:
	yych = *++cur;
	if (yych == 'H') goto yy653;
	if (yych == 'h') goto yy653;
	goto yy55;
yy468:
	yych = *++cur;
	if (yych == 'L') goto yy655;
	if (yych == 'l') goto yy655;
	goto yy55;
yy469:
	yych = *++cur;
	if (yych == 'A') goto yy656;
	if (yych == 'a') goto yy656;
	goto yy55;
yy470:
	yych = *++cur;
	if (yych == 'T') goto yy657;
	if (yych == 't') goto yy657;
	goto yy55;
yy471:
	yych = *++cur;
	if (yych == 'R') goto yy658;
	if (yych == 'r') goto yy658;
	goto yy55;
yy472:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 377 "tokenizer.re"
	{ KW(GOTO) }
#line 3894 "tokenizer.cpp"
yy474:
	yych = *++cur;
	if (yych == 'I') goto yy659;
	if (yych == 'i') goto yy659;
	goto yy55;
yy475:
	yych = *++cur;
	if (yych == 'R') goto yy660;
	if (yych == 'r') goto yy660;
	goto yy55;
yy476:
	yych = *++cur;
	if (yych == 'R') goto yy661;
	if (yych == 'r') goto yy661;
	goto yy55;
yy477:
	yych = *++cur;
	if (yych == 'U') goto yy662;
	if (yych == 'u') goto yy662;
	goto yy79;
yy478:
	yych = *++cur;
	if (yych == 'U') goto yy663;
	if (yych == 'u') goto yy663;
	goto yy55;
yy479:
	yych = *++cur;
	if (yych == 'T') goto yy664;
	if (yych == 't') goto yy664;
	goto yy55;
yy480:
	yych = *++cur;
	if (yych == 'I') goto yy666;
	if (yych == 'i') goto yy666;
	goto yy55;
yy481:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych <= 'M') {
			if (yych == 'G') goto yy667;
			goto yy55;
		} else {
			if (yych <= 'N') goto yy668;
			if (yych <= 'Q') goto yy55;
			goto yy669;
		}
	} else {
		if (yych <= 'm') {
			if (yych == 'g') goto yy667;
			goto yy55;
		} else {
			if (yych <= 'n') goto yy668;
			if (yych == 'r') goto yy669;
			goto yy55;
		}
	}
yy482:
	yych = *++cur;
	if (yych == 'I') goto yy670;
	if (yych == 'i') goto yy670;
	goto yy55;
yy483:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 392 "tokenizer.re"
	{ KW(KIND) }
#line 3964 "tokenizer.cpp"
yy485:
	yych = *++cur;
	if (yych == 'L') goto yy671;
	if (yych == 'l') goto yy671;
	goto yy55;
yy486:
	yych = *++cur;
	if (yych == 'C') goto yy673;
	if (yych == 'c') goto yy673;
	goto yy55;
yy487:
	yych = *++cur;
	if (yych == 'L') goto yy674;
	if (yych == 'l') goto yy674;
	goto yy55;
yy488:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 398 "tokenizer.re"
	{ KW(MOLD) }
#line 3988 "tokenizer.cpp"
yy490:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'L') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy491;
			if (yych <= 'K') goto yy54;
			goto yy675;
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 'l') goto yy675;
			if (yych <= 'z') goto yy54;
		}
	}
yy491:
#line 399 "tokenizer.re"
	{ KW(NAME) }
#line 4014 "tokenizer.cpp"
yy492:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 405 "tokenizer.re"
	{ KW(NONE) }
#line 4023 "tokenizer.cpp"
yy494:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych <= 'O') {
		if (yych <= '\'') {
			if (yych == '"') goto yy82;
			if (yych <= '&') goto yy55;
			goto yy97;
		} else {
			if (yych == 'I') goto yy676;
			if (yych <= 'N') goto yy55;
			goto yy677;
		}
	} else {
		if (yych <= 'i') {
			if (yych == 'R') goto yy678;
			if (yych <= 'h') goto yy55;
			goto yy676;
		} else {
			if (yych <= 'o') {
				if (yych <= 'n') goto yy55;
				goto yy677;
			} else {
				if (yych == 'r') goto yy678;
				goto yy55;
			}
		}
	}
yy495:
	yych = *++cur;
	if (yych == 'S') goto yy679;
	if (yych == 's') goto yy679;
	goto yy55;
yy496:
	yych = *++cur;
	if (yych == 'I') goto yy680;
	if (yych == 'i') goto yy680;
	goto yy55;
yy497:
	++cur;
#line 578 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 4066 "tokenizer.cpp"
yy499:
	++cur;
#line 579 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 4071 "tokenizer.cpp"
yy501:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 407 "tokenizer.re"
	{ KW(ONLY) }
#line 4080 "tokenizer.cpp"
yy503:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 408 "tokenizer.re"
	{ KW(OPEN) }
#line 4089 "tokenizer.cpp"
yy505:
	yych = *++cur;
	if (yych == 'A') goto yy681;
	if (yych == 'a') goto yy681;
	goto yy55;
yy506:
	yych = *++cur;
	if (yych == 'O') goto yy682;
	if (yych == 'o') goto yy682;
	goto yy55;
yy507:
	yych = *++cur;
	if (yych == 'M') goto yy683;
	if (yych == 'm') goto yy683;
	goto yy55;
yy508:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 413 "tokenizer.re"
	{ KW(PASS) }
#line 4113 "tokenizer.cpp"
yy510:
	yych = *++cur;
	if (yych == 'T') goto yy684;
	if (yych == 't') goto yy684;
	goto yy55;
yy511:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 415 "tokenizer.re"
	{ KW(POST) }
#line 4127 "tokenizer.cpp"
yy513:
	yych = *++cur;
	if (yych == 'I') goto yy685;
	if (yych == 'i') goto yy685;
	goto yy55;
yy514:
	yych = *++cur;
	if (yych == 'T') goto yy686;
	if (yych == 't') goto yy686;
	goto yy55;
yy515:
	yych = *++cur;
	if (yych == 'A') goto yy688;
	if (yych == 'a') goto yy688;
	goto yy55;
yy516:
	yych = *++cur;
	if (yych == 'E') goto yy689;
	if (yych == 'e') goto yy689;
	goto yy55;
yy517:
	yych = *++cur;
	if (yych == 'R') goto yy690;
	if (yych == 'r') goto yy690;
	goto yy55;
yy518:
	yych = *++cur;
	if (yych == 'E') goto yy691;
	if (yych == 'e') goto yy691;
	goto yy55;
yy519:
	yych = *++cur;
	if (yych == 'I') goto yy692;
	if (yych == 'i') goto yy692;
	goto yy55;
yy520:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 423 "tokenizer.re"
	{ KW(PURE) }
#line 4171 "tokenizer.cpp"
yy522:
	yych = *++cur;
	if (yych == 'T') goto yy693;
	if (yych == 't') goto yy693;
	goto yy55;
yy523:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 425 "tokenizer.re"
	{ KW(RANK) }
#line 4185 "tokenizer.cpp"
yy525:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 426 "tokenizer.re"
	{ KW(READ) }
#line 4194 "tokenizer.cpp"
yy527:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 427 "tokenizer.re"
	{KW(REAL) }
#line 4203 "tokenizer.cpp"
yy529:
	yych = *++cur;
	if (yych == 'R') goto yy695;
	if (yych == 'r') goto yy695;
	goto yy55;
yy530:
	yych = *++cur;
	if (yych == 'C') goto yy696;
	if (yych == 'c') goto yy696;
	goto yy55;
yy531:
	yych = *++cur;
	if (yych == 'L') goto yy697;
	if (yych == 'l') goto yy697;
	goto yy55;
yy532:
	yych = *++cur;
	if (yych == 'R') goto yy698;
	if (yych == 'r') goto yy698;
	goto yy55;
yy533:
	yych = *++cur;
	if (yych == 'N') goto yy699;
	if (yych == 'n') goto yy699;
	goto yy55;
yy534:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 433 "tokenizer.re"
	{ KW(SAVE) }
#line 4237 "tokenizer.cpp"
yy536:
	yych = *++cur;
	if (yych == 'C') goto yy700;
	if (yych == 'c') goto yy700;
	goto yy55;
yy537:
	yych = *++cur;
	if (yych == 'E') goto yy701;
	if (yych == 'e') goto yy701;
	goto yy55;
yy538:
	yych = *++cur;
	if (yych == 'E') goto yy702;
	if (yych == 'e') goto yy702;
	goto yy55;
yy539:
	yych = *++cur;
	if (yych == 'C') goto yy703;
	if (yych == 'c') goto yy703;
	goto yy55;
yy540:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 441 "tokenizer.re"
	{ KW(STAT) }
#line 4266 "tokenizer.cpp"
yy542:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 442 "tokenizer.re"
	{ KW(STOP) }
#line 4275 "tokenizer.cpp"
yy544:
	yych = *++cur;
	if (yych == 'O') goto yy704;
	if (yych == 'o') goto yy704;
	goto yy55;
yy545:
	yych = *++cur;
	if (yych == 'O') goto yy705;
	if (yych == 'o') goto yy705;
	goto yy55;
yy546:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 445 "tokenizer.re"
	{ KW(SYNC) }
#line 4294 "tokenizer.cpp"
yy548:
	yych = *++cur;
	if (yych == 'E') goto yy706;
	if (yych == 'e') goto yy706;
	goto yy55;
yy549:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy707;
#line 447 "tokenizer.re"
	{ KW(TEAM) }
#line 4308 "tokenizer.cpp"
yy551:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 449 "tokenizer.re"
	{ KW(THEN) }
#line 4317 "tokenizer.cpp"
yy553:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 451 "tokenizer.re"
	{ KW(TYPE) }
#line 4326 "tokenizer.cpp"
yy555:
	yych = *++cur;
	if (yych == 'R') goto yy708;
	if (yych == 'r') goto yy708;
	goto yy55;
yy556:
	yych = *++cur;
	if (yych == 'E') goto yy709;
	if (yych == 'e') goto yy709;
	goto yy55;
yy557:
	yych = *++cur;
	if (yych == 'T') goto yy711;
	if (yych == 't') goto yy711;
	goto yy55;
yy558:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 456 "tokenizer.re"
	{ KW(WAIT) }
#line 4350 "tokenizer.cpp"
yy560:
	yych = *++cur;
	if (yych == 'E') goto yy712;
	if (yych == 'e') goto yy712;
	goto yy55;
yy561:
	yych = *++cur;
	if (yych == 'E') goto yy714;
	if (yych == 'e') goto yy714;
	goto yy55;
yy562:
	yych = *++cur;
	if (yych == 'E') goto yy716;
	if (yych == 'e') goto yy716;
	goto yy55;
yy563:
	++cur;
#line 580 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 4370 "tokenizer.cpp"
yy565:
	++cur;
#line 581 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 4375 "tokenizer.cpp"
yy567:
	++cur;
	cur = ctxmar;
#line 483 "tokenizer.re"
	{ RET(TK_LPAREN) }
#line 4381 "tokenizer.cpp"
yy569:
	++cur;
#line 517 "tokenizer.re"
	{ RET(TK_AND) }
#line 4386 "tokenizer.cpp"
yy571:
	++cur;
#line 519 "tokenizer.re"
	{ RET(TK_EQV) }
#line 4391 "tokenizer.cpp"
yy573:
	yych = *++cur;
	if (yych == 'E') goto yy718;
	if (yych == 'e') goto yy718;
	goto yy111;
yy574:
	yych = *++cur;
	if (yych == '.') goto yy719;
	goto yy111;
yy575:
	++cur;
#line 516 "tokenizer.re"
	{ RET(TK_NOT) }
#line 4405 "tokenizer.cpp"
yy577:
	yych = *++cur;
	if (yych == '.') goto yy721;
	goto yy111;
yy578:
	yych = *++cur;
	if (yych == 'A') goto yy723;
	if (yych == 'a') goto yy723;
	goto yy55;
yy579:
	yych = *++cur;
	if (yych == 'A') goto yy724;
	if (yych == 'a') goto yy724;
	goto yy55;
yy580:
	yych = *++cur;
	if (yych == 'N') goto yy725;
	if (yych == 'n') goto yy725;
	goto yy55;
yy581:
	yych = *++cur;
	if (yych == 'I') goto yy727;
	if (yych == 'i') goto yy727;
	goto yy55;
yy582:
	yych = *++cur;
	if (yych == 'H') goto yy728;
	if (yych == 'h') goto yy728;
	goto yy55;
yy583:
	yych = *++cur;
	if (yych == 'P') goto yy729;
	if (yych == 'p') goto yy729;
	goto yy55;
yy584:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 238 "tokenizer.re"
	{ KW(BLOCK) }
#line 4448 "tokenizer.cpp"
yy586:
	yych = *++cur;
	if (yych == 'C') goto yy730;
	if (yych == 'c') goto yy730;
	goto yy55;
yy587:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 242 "tokenizer.re"
	{ KW(CLASS) }
#line 4462 "tokenizer.cpp"
yy589:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 243 "tokenizer.re"
	{ KW(CLOSE) }
#line 4471 "tokenizer.cpp"
yy591:
	yych = *++cur;
	if (yych == 'E') goto yy731;
	if (yych == 'e') goto yy731;
	goto yy55;
yy592:
	yych = *++cur;
	if (yych == 'N') goto yy732;
	if (yych == 'n') goto yy732;
	goto yy55;
yy593:
	yych = *++cur;
	if (yych == 'E') goto yy734;
	if (yych == 'e') goto yy734;
	goto yy55;
yy594:
	yych = *++cur;
	if (yych == 'R') goto yy735;
	if (yych == 'r') goto yy735;
	goto yy55;
yy595:
	yych = *++cur;
	if (yych == 'I') goto yy736;
	if (yych == 'i') goto yy736;
	goto yy55;
yy596:
	yych = *++cur;
	if (yych <= 'N') {
		if (yych == 'G') goto yy737;
		if (yych <= 'M') goto yy55;
		goto yy738;
	} else {
		if (yych <= 'g') {
			if (yych <= 'f') goto yy55;
			goto yy737;
		} else {
			if (yych == 'n') goto yy738;
			goto yy55;
		}
	}
yy597:
	yych = *++cur;
	if (yych == 'C') goto yy739;
	if (yych == 'c') goto yy739;
	goto yy55;
yy598:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 252 "tokenizer.re"
	{ KW(CYCLE) }
#line 4525 "tokenizer.cpp"
yy600:
	yych = *++cur;
	if (yych == 'O') goto yy740;
	if (yych == 'o') goto yy740;
	goto yy55;
yy601:
	yych = *++cur;
	if (yych == 'L') goto yy741;
	if (yych == 'l') goto yy741;
	goto yy55;
yy602:
	yych = *++cur;
	if (yych == 'R') goto yy742;
	if (yych == 'r') goto yy742;
	goto yy55;
yy603:
	yych = *++cur;
	if (yych == 'S') goto yy743;
	if (yych == 's') goto yy743;
	goto yy55;
yy604:
	yych = *++cur;
	if (yych == 'E') goto yy744;
	if (yych == 'e') goto yy744;
	goto yy55;
yy605:
	yych = *++cur;
	if (yych == 'L') goto yy746;
	if (yych == 'l') goto yy746;
	goto yy55;
yy606:
	yych = *++cur;
	if (yych == 'N') goto yy747;
	if (yych == 'n') goto yy747;
	goto yy55;
yy607:
	yych = *++cur;
	if (yych == 'F') goto yy748;
	if (yych == 'f') goto yy748;
	goto yy55;
yy608:
	yych = *++cur;
	if (yych == 'H') goto yy750;
	if (yych == 'h') goto yy750;
	goto yy55;
yy609:
	yych = *++cur;
	if (yych == 'S') goto yy751;
	if (yych == 's') goto yy751;
	goto yy79;
yy610:
	yych = *++cur;
	if (yych == 'L') goto yy752;
	if (yych == 'l') goto yy752;
	goto yy79;
yy611:
	yych = *++cur;
	if (yych == 'R') goto yy753;
	if (yych == 'r') goto yy753;
	goto yy79;
yy612:
	yych = *++cur;
	if (yych == 'O') goto yy754;
	if (yych == 'o') goto yy754;
	goto yy79;
yy613:
	yych = *++cur;
	if (yych == 'N') goto yy756;
	if (yych == 'n') goto yy756;
	goto yy79;
yy614:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych == 'O') goto yy757;
		if (yych <= 'T') goto yy79;
		goto yy758;
	} else {
		if (yych <= 'o') {
			if (yych <= 'n') goto yy79;
			goto yy757;
		} else {
			if (yych == 'u') goto yy758;
			goto yy79;
		}
	}
yy615:
	yych = *++cur;
	if (yych <= 'N') {
		if (yych == 'F') goto yy759;
		if (yych <= 'M') goto yy79;
		goto yy761;
	} else {
		if (yych <= 'f') {
			if (yych <= 'e') goto yy79;
			goto yy759;
		} else {
			if (yych == 'n') goto yy761;
			goto yy79;
		}
	}
yy616:
	yych = *++cur;
	if (yych == 'O') goto yy762;
	if (yych == 'o') goto yy762;
	goto yy79;
yy617:
	yych = *++cur;
	if (yych == 'R') goto yy763;
	if (yych == 'r') goto yy763;
	goto yy79;
yy618:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych == 'E') goto yy764;
		if (yych <= 'T') goto yy79;
		goto yy765;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy79;
			goto yy764;
		} else {
			if (yych == 'u') goto yy765;
			goto yy79;
		}
	}
yy619:
	yych = *++cur;
	if (yych == 'Y') goto yy766;
	if (yych == 'y') goto yy766;
	goto yy79;
yy620:
	yych = *++cur;
	if (yych == 'H') goto yy767;
	if (yych == 'h') goto yy767;
	goto yy79;
yy621:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych <= 'N') {
			if (yych == 'I') goto yy768;
			goto yy79;
		} else {
			if (yych <= 'O') goto yy757;
			if (yych <= 'T') goto yy79;
			goto yy758;
		}
	} else {
		if (yych <= 'n') {
			if (yych == 'i') goto yy768;
			goto yy79;
		} else {
			if (yych <= 'o') goto yy757;
			if (yych == 'u') goto yy758;
			goto yy79;
		}
	}
yy622:
	yych = *++cur;
	if (yych == 'S') goto yy769;
	if (yych == 's') goto yy769;
	goto yy55;
yy623:
	yych = *++cur;
	if (yych == 'O') goto yy770;
	if (yych == 'o') goto yy770;
	goto yy55;
yy624:
	yych = *++cur;
	if (yych == 'I') goto yy771;
	if (yych == 'i') goto yy771;
	goto yy55;
yy625:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 333 "tokenizer.re"
	{ 
                if (enddo_newline_process) {
                    KW(CONTINUE)
                } else {
                    KW(ENDDO)
                }
            }
#line 4711 "tokenizer.cpp"
yy627:
	yych = *++cur;
	if (yych == 'U') goto yy772;
	if (yych == 'u') goto yy772;
	goto yy55;
yy628:
	yych = *++cur;
	if (yych == 'L') goto yy773;
	if (yych == 'l') goto yy773;
	goto yy55;
yy629:
	yych = *++cur;
	if (yych == 'R') goto yy774;
	if (yych == 'r') goto yy774;
	goto yy55;
yy630:
	yych = *++cur;
	if (yych == 'N') goto yy775;
	if (yych == 'n') goto yy775;
	goto yy55;
yy631:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 318 "tokenizer.re"
	{ KW(ENDIF) }
#line 4740 "tokenizer.cpp"
yy633:
	yych = *++cur;
	if (yych == 'T') goto yy776;
	if (yych == 't') goto yy776;
	goto yy55;
yy634:
	yych = *++cur;
	if (yych == 'D') goto yy777;
	if (yych == 'd') goto yy777;
	goto yy55;
yy635:
	yych = *++cur;
	if (yych == 'O') goto yy778;
	if (yych == 'o') goto yy778;
	goto yy55;
yy636:
	yych = *++cur;
	if (yych == 'L') goto yy779;
	if (yych == 'l') goto yy779;
	goto yy55;
yy637:
	yych = *++cur;
	if (yych == 'B') goto yy780;
	if (yych == 'b') goto yy780;
	goto yy55;
yy638:
	yych = *++cur;
	if (yych == 'P') goto yy781;
	if (yych == 'p') goto yy781;
	goto yy55;
yy639:
	yych = *++cur;
	if (yych == 'E') goto yy782;
	if (yych == 'e') goto yy782;
	goto yy55;
yy640:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 347 "tokenizer.re"
	{ KW(ENTRY) }
#line 4784 "tokenizer.cpp"
yy642:
	yych = *++cur;
	if (yych == 'R') goto yy783;
	if (yych == 'r') goto yy783;
	goto yy55;
yy643:
	yych = *++cur;
	if (yych == 'A') goto yy784;
	if (yych == 'a') goto yy784;
	goto yy55;
yy644:
	yych = *++cur;
	if (yych == 'G') goto yy785;
	if (yych == 'g') goto yy785;
	goto yy55;
yy645:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 352 "tokenizer.re"
	{ KW(ERROR) }
#line 4808 "tokenizer.cpp"
yy647:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 353 "tokenizer.re"
	{ KW(EVENT) }
#line 4817 "tokenizer.cpp"
yy649:
	yych = *++cur;
	if (yych == 'D') goto yy787;
	if (yych == 'd') goto yy787;
	goto yy55;
yy650:
	yych = *++cur;
	if (yych == 'N') goto yy788;
	if (yych == 'n') goto yy788;
	goto yy55;
yy651:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 358 "tokenizer.re"
	{ KW(FINAL) }
#line 4836 "tokenizer.cpp"
yy653:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 359 "tokenizer.re"
	{ KW(FLUSH) }
#line 4845 "tokenizer.cpp"
yy655:
	yych = *++cur;
	if (yych == 'L') goto yy789;
	if (yych == 'l') goto yy789;
	goto yy55;
yy656:
	yych = *++cur;
	if (yych == 'T') goto yy791;
	if (yych == 't') goto yy791;
	goto yy55;
yy657:
	yych = *++cur;
	if (yych == 'I') goto yy793;
	if (yych == 'i') goto yy793;
	goto yy55;
yy658:
	yych = *++cur;
	if (yych == 'I') goto yy794;
	if (yych == 'i') goto yy794;
	goto yy55;
yy659:
	yych = *++cur;
	if (yych == 'C') goto yy795;
	if (yych == 'c') goto yy795;
	goto yy55;
yy660:
	yych = *++cur;
	if (yych == 'T') goto yy796;
	if (yych == 't') goto yy796;
	goto yy55;
yy661:
	yych = *++cur;
	if (yych == 'E') goto yy798;
	if (yych == 'e') goto yy798;
	goto yy55;
yy662:
	yych = *++cur;
	if (yych == 'T') goto yy800;
	if (yych == 't') goto yy800;
	goto yy79;
yy663:
	yych = *++cur;
	if (yych == 'D') goto yy802;
	if (yych == 'd') goto yy802;
	goto yy55;
yy664:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 384 "tokenizer.re"
	{ KW(INOUT) }
#line 4899 "tokenizer.cpp"
yy666:
	yych = *++cur;
	if (yych == 'R') goto yy803;
	if (yych == 'r') goto yy803;
	goto yy55;
yy667:
	yych = *++cur;
	if (yych == 'E') goto yy804;
	if (yych == 'e') goto yy804;
	goto yy55;
yy668:
	yych = *++cur;
	if (yych == 'T') goto yy805;
	if (yych == 't') goto yy805;
	goto yy55;
yy669:
	yych = *++cur;
	if (yych == 'F') goto yy807;
	if (yych == 'f') goto yy807;
	goto yy55;
yy670:
	yych = *++cur;
	if (yych == 'N') goto yy808;
	if (yych == 'n') goto yy808;
	goto yy55;
yy671:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy809;
#line 394 "tokenizer.re"
	{ KW(LOCAL) }
#line 4933 "tokenizer.cpp"
yy673:
	yych = *++cur;
	if (yych == 'A') goto yy810;
	if (yych == 'a') goto yy810;
	goto yy55;
yy674:
	yych = *++cur;
	if (yych == 'E') goto yy811;
	if (yych == 'e') goto yy811;
	goto yy55;
yy675:
	yych = *++cur;
	if (yych == 'I') goto yy813;
	if (yych == 'i') goto yy813;
	goto yy55;
yy676:
	yych = *++cur;
	if (yych == 'N') goto yy814;
	if (yych == 'n') goto yy814;
	goto yy55;
yy677:
	yych = *++cur;
	if (yych == 'V') goto yy815;
	if (yych == 'v') goto yy815;
	goto yy55;
yy678:
	yych = *++cur;
	if (yych == 'E') goto yy816;
	if (yych == 'e') goto yy816;
	goto yy55;
yy679:
	yych = *++cur;
	if (yych == 'S') goto yy817;
	if (yych == 's') goto yy817;
	goto yy55;
yy680:
	yych = *++cur;
	if (yych == 'F') goto yy819;
	if (yych == 'f') goto yy819;
	goto yy55;
yy681:
	yych = *++cur;
	if (yych == 'T') goto yy820;
	if (yych == 't') goto yy820;
	goto yy55;
yy682:
	yych = *++cur;
	if (yych == 'N') goto yy821;
	if (yych == 'n') goto yy821;
	goto yy55;
yy683:
	yych = *++cur;
	if (yych == 'E') goto yy822;
	if (yych == 'e') goto yy822;
	goto yy55;
yy684:
	yych = *++cur;
	if (yych == 'E') goto yy823;
	if (yych == 'e') goto yy823;
	goto yy55;
yy685:
	yych = *++cur;
	if (yych == 'S') goto yy824;
	if (yych == 's') goto yy824;
	goto yy55;
yy686:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 417 "tokenizer.re"
	{ KW(PRINT) }
#line 5007 "tokenizer.cpp"
yy688:
	yych = *++cur;
	if (yych == 'T') goto yy825;
	if (yych == 't') goto yy825;
	goto yy55;
yy689:
	yych = *++cur;
	if (yych == 'D') goto yy826;
	if (yych == 'd') goto yy826;
	goto yy55;
yy690:
	yych = *++cur;
	if (yych == 'A') goto yy827;
	if (yych == 'a') goto yy827;
	goto yy55;
yy691:
	yych = *++cur;
	if (yych == 'C') goto yy828;
	if (yych == 'c') goto yy828;
	goto yy55;
yy692:
	yych = *++cur;
	if (yych == 'C') goto yy829;
	if (yych == 'c') goto yy829;
	goto yy55;
yy693:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 424 "tokenizer.re"
	{ KW(QUIET) }
#line 5041 "tokenizer.cpp"
yy695:
	yych = *++cur;
	if (yych == 'S') goto yy831;
	if (yych == 's') goto yy831;
	goto yy55;
yy696:
	yych = *++cur;
	if (yych == 'E') goto yy832;
	if (yych == 'e') goto yy832;
	goto yy55;
yy697:
	yych = *++cur;
	if (yych == 'T') goto yy834;
	if (yych == 't') goto yy834;
	goto yy55;
yy698:
	yych = *++cur;
	if (yych == 'N') goto yy836;
	if (yych == 'n') goto yy836;
	goto yy55;
yy699:
	yych = *++cur;
	if (yych == 'D') goto yy838;
	if (yych == 'd') goto yy838;
	goto yy55;
yy700:
	yych = *++cur;
	if (yych == 'T') goto yy840;
	if (yych == 't') goto yy840;
	goto yy55;
yy701:
	yych = *++cur;
	if (yych == 'N') goto yy842;
	if (yych == 'n') goto yy842;
	goto yy55;
yy702:
	yych = *++cur;
	if (yych == 'D') goto yy843;
	if (yych == 'd') goto yy843;
	goto yy55;
yy703:
	yych = *++cur;
	if (yych == 'E') goto yy845;
	if (yych == 'e') goto yy845;
	goto yy55;
yy704:
	yych = *++cur;
	if (yych == 'D') goto yy847;
	if (yych == 'd') goto yy847;
	goto yy55;
yy705:
	yych = *++cur;
	if (yych == 'U') goto yy848;
	if (yych == 'u') goto yy848;
	goto yy55;
yy706:
	yych = *++cur;
	if (yych == 'T') goto yy849;
	if (yych == 't') goto yy849;
	goto yy55;
yy707:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych <= '\'') {
		if (yych == '"') goto yy82;
		if (yych <= '&') goto yy55;
		goto yy97;
	} else {
		if (yych <= 'N') {
			if (yych <= 'M') goto yy55;
			goto yy851;
		} else {
			if (yych == 'n') goto yy851;
			goto yy55;
		}
	}
yy708:
	yych = *++cur;
	if (yych == 'M') goto yy852;
	if (yych == 'm') goto yy852;
	goto yy55;
yy709:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 454 "tokenizer.re"
	{ KW(VALUE) }
#line 5131 "tokenizer.cpp"
yy711:
	yych = *++cur;
	if (yych == 'I') goto yy853;
	if (yych == 'i') goto yy853;
	goto yy55;
yy712:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 457 "tokenizer.re"
	{ KW(WHERE) }
#line 5145 "tokenizer.cpp"
yy714:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 458 "tokenizer.re"
	{ KW(WHILE) }
#line 5154 "tokenizer.cpp"
yy716:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 459 "tokenizer.re"
	{ KW(WRITE) }
#line 5163 "tokenizer.cpp"
yy718:
	yych = *++cur;
	if (yych == '.') goto yy854;
	goto yy111;
yy719:
	++cur;
#line 520 "tokenizer.re"
	{ RET(TK_NEQV) }
#line 5172 "tokenizer.cpp"
yy721:
	yyaccept = 11;
	yych = *(mar = ++cur);
	if (yych == '_') goto yy856;
yy722:
#line 524 "tokenizer.re"
	{ RET(TK_TRUE) }
#line 5180 "tokenizer.cpp"
yy723:
	yych = *++cur;
	if (yych == 'C') goto yy857;
	if (yych == 'c') goto yy857;
	goto yy55;
yy724:
	yych = *++cur;
	if (yych == 'T') goto yy858;
	if (yych == 't') goto yy858;
	goto yy55;
yy725:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'M') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy726;
			if (yych <= 'L') goto yy54;
			goto yy859;
		}
	} else {
		if (yych <= 'l') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 'm') goto yy859;
			if (yych <= 'z') goto yy54;
		}
	}
yy726:
#line 232 "tokenizer.re"
	{ KW(ASSIGN) }
#line 5216 "tokenizer.cpp"
yy727:
	yych = *++cur;
	if (yych == 'A') goto yy860;
	if (yych == 'a') goto yy860;
	goto yy55;
yy728:
	yych = *++cur;
	if (yych == 'R') goto yy861;
	if (yych == 'r') goto yy861;
	goto yy55;
yy729:
	yych = *++cur;
	if (yych == 'A') goto yy862;
	if (yych == 'a') goto yy862;
	goto yy55;
yy730:
	yych = *++cur;
	if (yych == 'T') goto yy863;
	if (yych == 't') goto yy863;
	goto yy55;
yy731:
	yych = *++cur;
	if (yych == 'N') goto yy864;
	if (yych == 'n') goto yy864;
	goto yy55;
yy732:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 245 "tokenizer.re"
	{ KW(COMMON) }
#line 5250 "tokenizer.cpp"
yy734:
	yych = *++cur;
	if (yych == 'X') goto yy865;
	if (yych == 'x') goto yy865;
	goto yy55;
yy735:
	yych = *++cur;
	if (yych == 'R') goto yy867;
	if (yych == 'r') goto yy867;
	goto yy55;
yy736:
	yych = *++cur;
	if (yych == 'N') goto yy868;
	if (yych == 'n') goto yy868;
	goto yy55;
yy737:
	yych = *++cur;
	if (yych == 'U') goto yy869;
	if (yych == 'u') goto yy869;
	goto yy55;
yy738:
	yych = *++cur;
	if (yych == 'U') goto yy870;
	if (yych == 'u') goto yy870;
	goto yy55;
yy739:
	yych = *++cur;
	if (yych == 'A') goto yy871;
	if (yych == 'a') goto yy871;
	goto yy55;
yy740:
	yych = *++cur;
	if (yych == 'C') goto yy872;
	if (yych == 'c') goto yy872;
	goto yy55;
yy741:
	yych = *++cur;
	if (yych == 'T') goto yy873;
	if (yych == 't') goto yy873;
	goto yy55;
yy742:
	yych = *++cur;
	if (yych == 'E') goto yy875;
	if (yych == 'e') goto yy875;
	goto yy55;
yy743:
	yych = *++cur;
	if (yych == 'I') goto yy876;
	if (yych == 'i') goto yy876;
	goto yy55;
yy744:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'P') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy745;
			if (yych <= 'O') goto yy54;
			goto yy877;
		}
	} else {
		if (yych <= 'o') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 'p') goto yy877;
			if (yych <= 'z') goto yy54;
		}
	}
yy745:
#line 267 "tokenizer.re"
	{ KW(DOUBLE) }
#line 5326 "tokenizer.cpp"
yy746:
	yych = *++cur;
	if (yych == 'E') goto yy878;
	if (yych == 'e') goto yy878;
	goto yy55;
yy747:
	yych = *++cur;
	if (yych == 'T') goto yy880;
	if (yych == 't') goto yy880;
	goto yy55;
yy748:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 271 "tokenizer.re"
	{ KW(ELSEIF) }
#line 5345 "tokenizer.cpp"
yy750:
	yych = *++cur;
	if (yych == 'E') goto yy881;
	if (yych == 'e') goto yy881;
	goto yy55;
yy751:
	yych = *++cur;
	if (yych == 'S') goto yy882;
	if (yych == 's') goto yy882;
	goto yy79;
yy752:
	yych = *++cur;
	if (yych == 'O') goto yy883;
	if (yych == 'o') goto yy883;
	goto yy79;
yy753:
	yych = *++cur;
	if (yych == 'I') goto yy884;
	if (yych == 'i') goto yy884;
	goto yy79;
yy754:
	++cur;
#line 326 "tokenizer.re"
	{ 
                if (enddo_newline_process) {
                    KW(CONTINUE)
                } else {
                    KW(END_DO)
                }
            }
#line 5376 "tokenizer.cpp"
yy756:
	yych = *++cur;
	if (yych == 'U') goto yy885;
	if (yych == 'u') goto yy885;
	goto yy79;
yy757:
	yych = *++cur;
	if (yych == 'R') goto yy886;
	if (yych == 'r') goto yy886;
	goto yy79;
yy758:
	yych = *++cur;
	if (yych == 'N') goto yy887;
	if (yych == 'n') goto yy887;
	goto yy79;
yy759:
	++cur;
#line 317 "tokenizer.re"
	{ KW(END_IF) }
#line 5396 "tokenizer.cpp"
yy761:
	yych = *++cur;
	if (yych == 'T') goto yy888;
	if (yych == 't') goto yy888;
	goto yy79;
yy762:
	yych = *++cur;
	if (yych == 'D') goto yy889;
	if (yych == 'd') goto yy889;
	goto yy79;
yy763:
	yych = *++cur;
	if (yych == 'O') goto yy890;
	if (yych == 'o') goto yy890;
	goto yy79;
yy764:
	yych = *++cur;
	if (yych == 'L') goto yy891;
	if (yych == 'l') goto yy891;
	goto yy79;
yy765:
	yych = *++cur;
	if (yych == 'B') goto yy892;
	if (yych == 'b') goto yy892;
	goto yy79;
yy766:
	yych = *++cur;
	if (yych == 'P') goto yy893;
	if (yych == 'p') goto yy893;
	goto yy79;
yy767:
	yych = *++cur;
	if (yych == 'E') goto yy894;
	if (yych == 'e') goto yy894;
	goto yy79;
yy768:
	yych = *++cur;
	if (yych == 'L') goto yy895;
	if (yych == 'l') goto yy895;
	goto yy79;
yy769:
	yych = *++cur;
	if (yych == 'O') goto yy896;
	if (yych == 'o') goto yy896;
	goto yy55;
yy770:
	yych = *++cur;
	if (yych == 'C') goto yy897;
	if (yych == 'c') goto yy897;
	goto yy55;
yy771:
	yych = *++cur;
	if (yych == 'T') goto yy898;
	if (yych == 't') goto yy898;
	goto yy55;
yy772:
	yych = *++cur;
	if (yych == 'M') goto yy899;
	if (yych == 'm') goto yy899;
	goto yy55;
yy773:
	yych = *++cur;
	if (yych == 'E') goto yy901;
	if (yych == 'e') goto yy901;
	goto yy55;
yy774:
	yych = *++cur;
	if (yych == 'A') goto yy903;
	if (yych == 'a') goto yy903;
	goto yy55;
yy775:
	yych = *++cur;
	if (yych == 'C') goto yy904;
	if (yych == 'c') goto yy904;
	goto yy55;
yy776:
	yych = *++cur;
	if (yych == 'E') goto yy905;
	if (yych == 'e') goto yy905;
	goto yy55;
yy777:
	yych = *++cur;
	if (yych == 'U') goto yy906;
	if (yych == 'u') goto yy906;
	goto yy55;
yy778:
	yych = *++cur;
	if (yych <= 'G') {
		if (yych == 'C') goto yy907;
		if (yych <= 'F') goto yy55;
		goto yy908;
	} else {
		if (yych <= 'c') {
			if (yych <= 'b') goto yy55;
			goto yy907;
		} else {
			if (yych == 'g') goto yy908;
			goto yy55;
		}
	}
yy779:
	yych = *++cur;
	if (yych == 'E') goto yy909;
	if (yych == 'e') goto yy909;
	goto yy55;
yy780:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'M') goto yy910;
		if (yych <= 'Q') goto yy55;
		goto yy911;
	} else {
		if (yych <= 'm') {
			if (yych <= 'l') goto yy55;
			goto yy910;
		} else {
			if (yych == 'r') goto yy911;
			goto yy55;
		}
	}
yy781:
	yych = *++cur;
	if (yych == 'E') goto yy912;
	if (yych == 'e') goto yy912;
	goto yy55;
yy782:
	yych = *++cur;
	if (yych == 'R') goto yy914;
	if (yych == 'r') goto yy914;
	goto yy55;
yy783:
	yych = *++cur;
	if (yych == 'A') goto yy915;
	if (yych == 'a') goto yy915;
	goto yy55;
yy784:
	yych = *++cur;
	if (yych == 'L') goto yy916;
	if (yych == 'l') goto yy916;
	goto yy55;
yy785:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 351 "tokenizer.re"
	{ KW(ERRMSG) }
#line 5545 "tokenizer.cpp"
yy787:
	yych = *++cur;
	if (yych == 'S') goto yy917;
	if (yych == 's') goto yy917;
	goto yy55;
yy788:
	yych = *++cur;
	if (yych == 'A') goto yy919;
	if (yych == 'a') goto yy919;
	goto yy55;
yy789:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 360 "tokenizer.re"
	{ KW(FORALL) }
#line 5564 "tokenizer.cpp"
yy791:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'T') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy792;
			if (yych <= 'S') goto yy54;
			goto yy920;
		}
	} else {
		if (yych <= 's') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 't') goto yy920;
			if (yych <= 'z') goto yy54;
		}
	}
yy792:
#line 361 "tokenizer.re"
	{
                if (last_token == yytokentype::TK_LABEL) {
                    unsigned char *start;
                    lex_format(cur, loc, start);
                    yylval.string.p = (char*) start;
                    yylval.string.n = cur-start-1;
                    RET(TK_FORMAT)
                } else {
                    token(yylval.string);
                    RET(TK_NAME)
                }
            }
#line 5601 "tokenizer.cpp"
yy793:
	yych = *++cur;
	if (yych == 'O') goto yy921;
	if (yych == 'o') goto yy921;
	goto yy55;
yy794:
	yych = *++cur;
	if (yych == 'C') goto yy922;
	if (yych == 'c') goto yy922;
	goto yy55;
yy795:
	yych = *++cur;
	if (yych == 'I') goto yy924;
	if (yych == 'i') goto yy924;
	goto yy55;
yy796:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 380 "tokenizer.re"
	{ KW(IMPORT) }
#line 5625 "tokenizer.cpp"
yy798:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 381 "tokenizer.re"
	{ KW(IMPURE) }
#line 5634 "tokenizer.cpp"
yy800:
	++cur;
#line 385 "tokenizer.re"
	{ KW(IN_OUT) }
#line 5639 "tokenizer.cpp"
yy802:
	yych = *++cur;
	if (yych == 'E') goto yy925;
	if (yych == 'e') goto yy925;
	goto yy55;
yy803:
	yych = *++cur;
	if (yych == 'E') goto yy927;
	if (yych == 'e') goto yy927;
	goto yy55;
yy804:
	yych = *++cur;
	if (yych == 'R') goto yy929;
	if (yych == 'r') goto yy929;
	goto yy55;
yy805:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 388 "tokenizer.re"
	{ KW(INTENT) }
#line 5663 "tokenizer.cpp"
yy807:
	yych = *++cur;
	if (yych == 'A') goto yy931;
	if (yych == 'a') goto yy931;
	goto yy55;
yy808:
	yych = *++cur;
	if (yych == 'S') goto yy932;
	if (yych == 's') goto yy932;
	goto yy55;
yy809:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych <= '\'') {
		if (yych == '"') goto yy82;
		if (yych <= '&') goto yy55;
		goto yy97;
	} else {
		if (yych <= 'I') {
			if (yych <= 'H') goto yy55;
			goto yy933;
		} else {
			if (yych == 'i') goto yy933;
			goto yy55;
		}
	}
yy810:
	yych = *++cur;
	if (yych == 'L') goto yy934;
	if (yych == 'l') goto yy934;
	goto yy55;
yy811:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 397 "tokenizer.re"
	{ KW(MODULE) }
#line 5703 "tokenizer.cpp"
yy813:
	yych = *++cur;
	if (yych == 'S') goto yy936;
	if (yych == 's') goto yy936;
	goto yy55;
yy814:
	yych = *++cur;
	if (yych == 'T') goto yy937;
	if (yych == 't') goto yy937;
	goto yy55;
yy815:
	yych = *++cur;
	if (yych == 'E') goto yy938;
	if (yych == 'e') goto yy938;
	goto yy55;
yy816:
	yych = *++cur;
	if (yych == 'C') goto yy939;
	if (yych == 'c') goto yy939;
	goto yy55;
yy817:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 401 "tokenizer.re"
	{ KW(NOPASS) }
#line 5732 "tokenizer.cpp"
yy819:
	yych = *++cur;
	if (yych == 'Y') goto yy940;
	if (yych == 'y') goto yy940;
	goto yy55;
yy820:
	yych = *++cur;
	if (yych == 'O') goto yy942;
	if (yych == 'o') goto yy942;
	goto yy55;
yy821:
	yych = *++cur;
	if (yych == 'A') goto yy943;
	if (yych == 'a') goto yy943;
	goto yy55;
yy822:
	yych = *++cur;
	if (yych == 'T') goto yy944;
	if (yych == 't') goto yy944;
	goto yy55;
yy823:
	yych = *++cur;
	if (yych == 'R') goto yy945;
	if (yych == 'r') goto yy945;
	goto yy55;
yy824:
	yych = *++cur;
	if (yych == 'I') goto yy947;
	if (yych == 'i') goto yy947;
	goto yy55;
yy825:
	yych = *++cur;
	if (yych == 'E') goto yy948;
	if (yych == 'e') goto yy948;
	goto yy55;
yy826:
	yych = *++cur;
	if (yych == 'U') goto yy950;
	if (yych == 'u') goto yy950;
	goto yy55;
yy827:
	yych = *++cur;
	if (yych == 'M') goto yy951;
	if (yych == 'm') goto yy951;
	goto yy55;
yy828:
	yych = *++cur;
	if (yych == 'T') goto yy953;
	if (yych == 't') goto yy953;
	goto yy55;
yy829:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 422 "tokenizer.re"
	{ KW(PUBLIC) }
#line 5791 "tokenizer.cpp"
yy831:
	yych = *++cur;
	if (yych == 'I') goto yy954;
	if (yych == 'i') goto yy954;
	goto yy55;
yy832:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 429 "tokenizer.re"
	{ KW(REDUCE) }
#line 5805 "tokenizer.cpp"
yy834:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 430 "tokenizer.re"
	{ KW(RESULT) }
#line 5814 "tokenizer.cpp"
yy836:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 431 "tokenizer.re"
	{ KW(RETURN) }
#line 5823 "tokenizer.cpp"
yy838:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 432 "tokenizer.re"
	{ KW(REWIND) }
#line 5832 "tokenizer.cpp"
yy840:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'T') {
		if (yych <= 'B') {
			if (yych <= '/') goto yy841;
			if (yych <= '9') goto yy54;
			if (yych >= 'A') goto yy54;
		} else {
			if (yych <= 'Q') {
				if (yych <= 'C') goto yy955;
				goto yy54;
			} else {
				if (yych <= 'R') goto yy956;
				if (yych <= 'S') goto yy54;
				goto yy957;
			}
		}
	} else {
		if (yych <= 'q') {
			if (yych <= '`') {
				if (yych <= 'Z') goto yy54;
			} else {
				if (yych == 'c') goto yy955;
				goto yy54;
			}
		} else {
			if (yych <= 's') {
				if (yych <= 'r') goto yy956;
				goto yy54;
			} else {
				if (yych <= 't') goto yy957;
				if (yych <= 'z') goto yy54;
			}
		}
	}
yy841:
#line 434 "tokenizer.re"
	{ KW(SELECT) }
#line 5874 "tokenizer.cpp"
yy842:
	yych = *++cur;
	if (yych == 'C') goto yy958;
	if (yych == 'c') goto yy958;
	goto yy55;
yy843:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 439 "tokenizer.re"
	{ KW(SHARED) }
#line 5888 "tokenizer.cpp"
yy845:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 440 "tokenizer.re"
	{ KW(SOURCE) }
#line 5897 "tokenizer.cpp"
yy847:
	yych = *++cur;
	if (yych == 'U') goto yy959;
	if (yych == 'u') goto yy959;
	goto yy55;
yy848:
	yych = *++cur;
	if (yych == 'T') goto yy960;
	if (yych == 't') goto yy960;
	goto yy55;
yy849:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 446 "tokenizer.re"
	{ KW(TARGET) }
#line 5916 "tokenizer.cpp"
yy851:
	yych = *++cur;
	if (yych == 'U') goto yy961;
	if (yych == 'u') goto yy961;
	goto yy55;
yy852:
	yych = *++cur;
	if (yych == 'A') goto yy962;
	if (yych == 'a') goto yy962;
	goto yy55;
yy853:
	yych = *++cur;
	if (yych == 'L') goto yy963;
	if (yych == 'l') goto yy963;
	goto yy55;
yy854:
	yyaccept = 12;
	yych = *(mar = ++cur);
	if (yych == '_') goto yy964;
yy855:
#line 525 "tokenizer.re"
	{ RET(TK_FALSE) }
#line 5939 "tokenizer.cpp"
yy856:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy79;
		if (yych <= '9') goto yy965;
		if (yych <= '@') goto yy79;
		goto yy967;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy79;
			goto yy967;
		} else {
			if (yych <= '`') goto yy79;
			if (yych <= 'z') goto yy967;
			goto yy79;
		}
	}
yy857:
	yych = *++cur;
	if (yych == 'T') goto yy969;
	if (yych == 't') goto yy969;
	goto yy55;
yy858:
	yych = *++cur;
	if (yych <= 'E') {
		if (yych == 'A') goto yy971;
		if (yych <= 'D') goto yy55;
		goto yy972;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy971;
		} else {
			if (yych == 'e') goto yy972;
			goto yy55;
		}
	}
yy859:
	yych = *++cur;
	if (yych == 'E') goto yy974;
	if (yych == 'e') goto yy974;
	goto yy55;
yy860:
	yych = *++cur;
	if (yych == 'T') goto yy975;
	if (yych == 't') goto yy975;
	goto yy55;
yy861:
	yych = *++cur;
	if (yych == 'O') goto yy976;
	if (yych == 'o') goto yy976;
	goto yy55;
yy862:
	yych = *++cur;
	if (yych == 'C') goto yy977;
	if (yych == 'c') goto yy977;
	goto yy55;
yy863:
	yych = *++cur;
	if (yych == 'E') goto yy978;
	if (yych == 'e') goto yy978;
	goto yy55;
yy864:
	yych = *++cur;
	if (yych == 'S') goto yy979;
	if (yych == 's') goto yy979;
	goto yy55;
yy865:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 246 "tokenizer.re"
	{ KW(COMPLEX) }
#line 6015 "tokenizer.cpp"
yy867:
	yych = *++cur;
	if (yych == 'E') goto yy980;
	if (yych == 'e') goto yy980;
	goto yy55;
yy868:
	yych = *++cur;
	if (yych == 'S') goto yy981;
	if (yych == 's') goto yy981;
	goto yy55;
yy869:
	yych = *++cur;
	if (yych == 'O') goto yy983;
	if (yych == 'o') goto yy983;
	goto yy55;
yy870:
	yych = *++cur;
	if (yych == 'E') goto yy984;
	if (yych == 'e') goto yy984;
	goto yy55;
yy871:
	yych = *++cur;
	if (yych == 'L') goto yy986;
	if (yych == 'l') goto yy986;
	goto yy55;
yy872:
	yych = *++cur;
	if (yych == 'A') goto yy988;
	if (yych == 'a') goto yy988;
	goto yy55;
yy873:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 255 "tokenizer.re"
	{ KW(DEFAULT) }
#line 6054 "tokenizer.cpp"
yy875:
	yych = *++cur;
	if (yych == 'D') goto yy989;
	if (yych == 'd') goto yy989;
	goto yy55;
yy876:
	yych = *++cur;
	if (yych == 'O') goto yy991;
	if (yych == 'o') goto yy991;
	goto yy55;
yy877:
	yych = *++cur;
	if (yych == 'R') goto yy992;
	if (yych == 'r') goto yy992;
	goto yy55;
yy878:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 266 "tokenizer.re"
	{ KW(DOWHILE) }
#line 6078 "tokenizer.cpp"
yy880:
	yych = *++cur;
	if (yych == 'A') goto yy993;
	if (yych == 'a') goto yy993;
	goto yy55;
yy881:
	yych = *++cur;
	if (yych == 'R') goto yy994;
	if (yych == 'r') goto yy994;
	goto yy55;
yy882:
	yych = *++cur;
	if (yych == 'O') goto yy995;
	if (yych == 'o') goto yy995;
	goto yy79;
yy883:
	yych = *++cur;
	if (yych == 'C') goto yy996;
	if (yych == 'c') goto yy996;
	goto yy79;
yy884:
	yych = *++cur;
	if (yych == 'T') goto yy997;
	if (yych == 't') goto yy997;
	goto yy79;
yy885:
	yych = *++cur;
	if (yych == 'M') goto yy998;
	if (yych == 'm') goto yy998;
	goto yy79;
yy886:
	yych = *++cur;
	if (yych == 'A') goto yy1000;
	if (yych == 'a') goto yy1000;
	goto yy79;
yy887:
	yych = *++cur;
	if (yych == 'C') goto yy1001;
	if (yych == 'c') goto yy1001;
	goto yy79;
yy888:
	yych = *++cur;
	if (yych == 'E') goto yy1002;
	if (yych == 'e') goto yy1002;
	goto yy79;
yy889:
	yych = *++cur;
	if (yych == 'U') goto yy1003;
	if (yych == 'u') goto yy1003;
	goto yy79;
yy890:
	yych = *++cur;
	if (yych <= 'G') {
		if (yych == 'C') goto yy1004;
		if (yych <= 'F') goto yy79;
		goto yy1005;
	} else {
		if (yych <= 'c') {
			if (yych <= 'b') goto yy79;
			goto yy1004;
		} else {
			if (yych == 'g') goto yy1005;
			goto yy79;
		}
	}
yy891:
	yych = *++cur;
	if (yych == 'E') goto yy1006;
	if (yych == 'e') goto yy1006;
	goto yy79;
yy892:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'M') goto yy1007;
		if (yych <= 'Q') goto yy79;
		goto yy1008;
	} else {
		if (yych <= 'm') {
			if (yych <= 'l') goto yy79;
			goto yy1007;
		} else {
			if (yych == 'r') goto yy1008;
			goto yy79;
		}
	}
yy893:
	yych = *++cur;
	if (yych == 'E') goto yy1009;
	if (yych == 'e') goto yy1009;
	goto yy79;
yy894:
	yych = *++cur;
	if (yych == 'R') goto yy1011;
	if (yych == 'r') goto yy1011;
	goto yy79;
yy895:
	yych = *++cur;
	if (yych == 'E') goto yy1012;
	if (yych == 'e') goto yy1012;
	goto yy79;
yy896:
	yych = *++cur;
	if (yych == 'C') goto yy1014;
	if (yych == 'c') goto yy1014;
	goto yy55;
yy897:
	yych = *++cur;
	if (yych == 'K') goto yy1015;
	if (yych == 'k') goto yy1015;
	goto yy55;
yy898:
	yych = *++cur;
	if (yych == 'I') goto yy1017;
	if (yych == 'i') goto yy1017;
	goto yy55;
yy899:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 303 "tokenizer.re"
	{ KW(ENDENUM) }
#line 6202 "tokenizer.cpp"
yy901:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 345 "tokenizer.re"
	{ KW(ENDFILE) }
#line 6211 "tokenizer.cpp"
yy903:
	yych = *++cur;
	if (yych == 'L') goto yy1018;
	if (yych == 'l') goto yy1018;
	goto yy55;
yy904:
	yych = *++cur;
	if (yych == 'T') goto yy1019;
	if (yych == 't') goto yy1019;
	goto yy55;
yy905:
	yych = *++cur;
	if (yych == 'R') goto yy1020;
	if (yych == 'r') goto yy1020;
	goto yy55;
yy906:
	yych = *++cur;
	if (yych == 'L') goto yy1021;
	if (yych == 'l') goto yy1021;
	goto yy55;
yy907:
	yych = *++cur;
	if (yych == 'E') goto yy1022;
	if (yych == 'e') goto yy1022;
	goto yy55;
yy908:
	yych = *++cur;
	if (yych == 'R') goto yy1023;
	if (yych == 'r') goto yy1023;
	goto yy55;
yy909:
	yych = *++cur;
	if (yych == 'C') goto yy1024;
	if (yych == 'c') goto yy1024;
	goto yy55;
yy910:
	yych = *++cur;
	if (yych == 'O') goto yy1025;
	if (yych == 'o') goto yy1025;
	goto yy55;
yy911:
	yych = *++cur;
	if (yych == 'O') goto yy1026;
	if (yych == 'o') goto yy1026;
	goto yy55;
yy912:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 324 "tokenizer.re"
	{ KW(ENDTYPE) }
#line 6265 "tokenizer.cpp"
yy914:
	yych = *++cur;
	if (yych == 'E') goto yy1027;
	if (yych == 'e') goto yy1027;
	goto yy55;
yy915:
	yych = *++cur;
	if (yych == 'T') goto yy1029;
	if (yych == 't') goto yy1029;
	goto yy55;
yy916:
	yych = *++cur;
	if (yych == 'E') goto yy1030;
	if (yych == 'e') goto yy1030;
	goto yy55;
yy917:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 355 "tokenizer.re"
	{ KW(EXTENDS) }
#line 6289 "tokenizer.cpp"
yy919:
	yych = *++cur;
	if (yych == 'L') goto yy1031;
	if (yych == 'l') goto yy1031;
	goto yy55;
yy920:
	yych = *++cur;
	if (yych == 'E') goto yy1033;
	if (yych == 'e') goto yy1033;
	goto yy55;
yy921:
	yych = *++cur;
	if (yych == 'N') goto yy1034;
	if (yych == 'n') goto yy1034;
	goto yy55;
yy922:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 375 "tokenizer.re"
	{ KW(GENERIC) }
#line 6313 "tokenizer.cpp"
yy924:
	yych = *++cur;
	if (yych == 'T') goto yy1036;
	if (yych == 't') goto yy1036;
	goto yy55;
yy925:
	yyaccept = 13;
	yych = *(mar = ++cur);
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych >= '\t') goto yy1038;
		} else {
			if (yych == '\v') goto yy1038;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy1038;
			if (yych >= ' ') goto yy1038;
		} else {
			if (yych == '_') goto yy143;
		}
	}
yy926:
#line 383 "tokenizer.re"
	{ KW(INCLUDE) }
#line 6342 "tokenizer.cpp"
yy927:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 386 "tokenizer.re"
	{ KW(INQUIRE) }
#line 6351 "tokenizer.cpp"
yy929:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 387 "tokenizer.re"
	{ KW(INTEGER) }
#line 6360 "tokenizer.cpp"
yy931:
	yych = *++cur;
	if (yych == 'C') goto yy1040;
	if (yych == 'c') goto yy1040;
	goto yy55;
yy932:
	yych = *++cur;
	if (yych == 'I') goto yy1041;
	if (yych == 'i') goto yy1041;
	goto yy55;
yy933:
	yych = *++cur;
	if (yych == 'N') goto yy1042;
	if (yych == 'n') goto yy1042;
	goto yy55;
yy934:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 396 "tokenizer.re"
	{ KW(LOGICAL) }
#line 6384 "tokenizer.cpp"
yy936:
	yych = *++cur;
	if (yych == 'T') goto yy1043;
	if (yych == 't') goto yy1043;
	goto yy55;
yy937:
	yych = *++cur;
	if (yych == 'R') goto yy1045;
	if (yych == 'r') goto yy1045;
	goto yy55;
yy938:
	yych = *++cur;
	if (yych == 'R') goto yy1046;
	if (yych == 'r') goto yy1046;
	goto yy55;
yy939:
	yych = *++cur;
	if (yych == 'U') goto yy1047;
	if (yych == 'u') goto yy1047;
	goto yy55;
yy940:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 406 "tokenizer.re"
	{ KW(NULLIFY) }
#line 6413 "tokenizer.cpp"
yy942:
	yych = *++cur;
	if (yych == 'R') goto yy1048;
	if (yych == 'r') goto yy1048;
	goto yy55;
yy943:
	yych = *++cur;
	if (yych == 'L') goto yy1050;
	if (yych == 'l') goto yy1050;
	goto yy55;
yy944:
	yych = *++cur;
	if (yych == 'E') goto yy1052;
	if (yych == 'e') goto yy1052;
	goto yy55;
yy945:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 414 "tokenizer.re"
	{ KW(POINTER) }
#line 6437 "tokenizer.cpp"
yy947:
	yych = *++cur;
	if (yych == 'O') goto yy1053;
	if (yych == 'o') goto yy1053;
	goto yy55;
yy948:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 418 "tokenizer.re"
	{ KW(PRIVATE) }
#line 6451 "tokenizer.cpp"
yy950:
	yych = *++cur;
	if (yych == 'R') goto yy1054;
	if (yych == 'r') goto yy1054;
	goto yy55;
yy951:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 420 "tokenizer.re"
	{ KW(PROGRAM) }
#line 6465 "tokenizer.cpp"
yy953:
	yych = *++cur;
	if (yych == 'E') goto yy1055;
	if (yych == 'e') goto yy1055;
	goto yy55;
yy954:
	yych = *++cur;
	if (yych == 'V') goto yy1056;
	if (yych == 'v') goto yy1056;
	goto yy55;
yy955:
	yych = *++cur;
	if (yych == 'A') goto yy1057;
	if (yych == 'a') goto yy1057;
	goto yy55;
yy956:
	yych = *++cur;
	if (yych == 'A') goto yy1058;
	if (yych == 'a') goto yy1058;
	goto yy55;
yy957:
	yych = *++cur;
	if (yych == 'Y') goto yy1059;
	if (yych == 'y') goto yy1059;
	goto yy55;
yy958:
	yych = *++cur;
	if (yych == 'E') goto yy1060;
	if (yych == 'e') goto yy1060;
	goto yy55;
yy959:
	yych = *++cur;
	if (yych == 'L') goto yy1062;
	if (yych == 'l') goto yy1062;
	goto yy55;
yy960:
	yych = *++cur;
	if (yych == 'I') goto yy1063;
	if (yych == 'i') goto yy1063;
	goto yy55;
yy961:
	yych = *++cur;
	if (yych == 'M') goto yy1064;
	if (yych == 'm') goto yy1064;
	goto yy55;
yy962:
	yych = *++cur;
	if (yych == 'T') goto yy1065;
	if (yych == 't') goto yy1065;
	goto yy55;
yy963:
	yych = *++cur;
	if (yych == 'E') goto yy1066;
	if (yych == 'e') goto yy1066;
	goto yy55;
yy964:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy79;
		if (yych <= '9') goto yy1068;
		if (yych <= '@') goto yy79;
		goto yy1070;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy79;
			goto yy1070;
		} else {
			if (yych <= '`') goto yy79;
			if (yych <= 'z') goto yy1070;
			goto yy79;
		}
	}
yy965:
	yych = *++cur;
	if (yych <= '/') goto yy722;
	if (yych <= '9') goto yy965;
	goto yy722;
yy967:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy722;
		if (yych <= '9') goto yy967;
		if (yych <= '@') goto yy722;
		goto yy967;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy722;
			goto yy967;
		} else {
			if (yych <= '`') goto yy722;
			if (yych <= 'z') goto yy967;
			goto yy722;
		}
	}
yy969:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 228 "tokenizer.re"
	{ KW(ABSTRACT) }
#line 6568 "tokenizer.cpp"
yy971:
	yych = *++cur;
	if (yych == 'B') goto yy1072;
	if (yych == 'b') goto yy1072;
	goto yy55;
yy972:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 231 "tokenizer.re"
	{ KW(ALLOCATE) }
#line 6582 "tokenizer.cpp"
yy974:
	yych = *++cur;
	if (yych == 'N') goto yy1073;
	if (yych == 'n') goto yy1073;
	goto yy55;
yy975:
	yych = *++cur;
	if (yych == 'E') goto yy1074;
	if (yych == 'e') goto yy1074;
	goto yy55;
yy976:
	yych = *++cur;
	if (yych == 'N') goto yy1076;
	if (yych == 'n') goto yy1076;
	goto yy55;
yy977:
	yych = *++cur;
	if (yych == 'E') goto yy1077;
	if (yych == 'e') goto yy1077;
	goto yy55;
yy978:
	yych = *++cur;
	if (yych == 'R') goto yy1079;
	if (yych == 'r') goto yy1079;
	goto yy55;
yy979:
	yych = *++cur;
	if (yych == 'I') goto yy1081;
	if (yych == 'i') goto yy1081;
	goto yy55;
yy980:
	yych = *++cur;
	if (yych == 'N') goto yy1082;
	if (yych == 'n') goto yy1082;
	goto yy55;
yy981:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 248 "tokenizer.re"
	{ KW(CONTAINS) }
#line 6626 "tokenizer.cpp"
yy983:
	yych = *++cur;
	if (yych == 'U') goto yy1083;
	if (yych == 'u') goto yy1083;
	goto yy55;
yy984:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 250 "tokenizer.re"
	{ KW(CONTINUE) }
#line 6640 "tokenizer.cpp"
yy986:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 251 "tokenizer.re"
	{ KW(CRITICAL) }
#line 6649 "tokenizer.cpp"
yy988:
	yych = *++cur;
	if (yych == 'T') goto yy1084;
	if (yych == 't') goto yy1084;
	goto yy55;
yy989:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 256 "tokenizer.re"
	{ KW(DEFERRED) }
#line 6663 "tokenizer.cpp"
yy991:
	yych = *++cur;
	if (yych == 'N') goto yy1085;
	if (yych == 'n') goto yy1085;
	goto yy55;
yy992:
	yych = *++cur;
	if (yych == 'E') goto yy1087;
	if (yych == 'e') goto yy1087;
	goto yy55;
yy993:
	yych = *++cur;
	if (yych == 'L') goto yy1088;
	if (yych == 'l') goto yy1088;
	goto yy55;
yy994:
	yych = *++cur;
	if (yych == 'E') goto yy1090;
	if (yych == 'e') goto yy1090;
	goto yy55;
yy995:
	yych = *++cur;
	if (yych == 'C') goto yy1092;
	if (yych == 'c') goto yy1092;
	goto yy79;
yy996:
	yych = *++cur;
	if (yych == 'K') goto yy1093;
	if (yych == 'k') goto yy1093;
	goto yy79;
yy997:
	yych = *++cur;
	if (yych == 'I') goto yy1095;
	if (yych == 'i') goto yy1095;
	goto yy79;
yy998:
	++cur;
#line 302 "tokenizer.re"
	{ KW(END_ENUM) }
#line 6703 "tokenizer.cpp"
yy1000:
	yych = *++cur;
	if (yych == 'L') goto yy1096;
	if (yych == 'l') goto yy1096;
	goto yy79;
yy1001:
	yych = *++cur;
	if (yych == 'T') goto yy1097;
	if (yych == 't') goto yy1097;
	goto yy79;
yy1002:
	yych = *++cur;
	if (yych == 'R') goto yy1098;
	if (yych == 'r') goto yy1098;
	goto yy79;
yy1003:
	yych = *++cur;
	if (yych == 'L') goto yy1099;
	if (yych == 'l') goto yy1099;
	goto yy79;
yy1004:
	yych = *++cur;
	if (yych == 'E') goto yy1100;
	if (yych == 'e') goto yy1100;
	goto yy79;
yy1005:
	yych = *++cur;
	if (yych == 'R') goto yy1101;
	if (yych == 'r') goto yy1101;
	goto yy79;
yy1006:
	yych = *++cur;
	if (yych == 'C') goto yy1102;
	if (yych == 'c') goto yy1102;
	goto yy79;
yy1007:
	yych = *++cur;
	if (yych == 'O') goto yy1103;
	if (yych == 'o') goto yy1103;
	goto yy79;
yy1008:
	yych = *++cur;
	if (yych == 'O') goto yy1104;
	if (yych == 'o') goto yy1104;
	goto yy79;
yy1009:
	++cur;
#line 323 "tokenizer.re"
	{ KW(END_TYPE) }
#line 6753 "tokenizer.cpp"
yy1011:
	yych = *++cur;
	if (yych == 'E') goto yy1105;
	if (yych == 'e') goto yy1105;
	goto yy79;
yy1012:
	++cur;
#line 344 "tokenizer.re"
	{ KW(END_FILE) }
#line 6763 "tokenizer.cpp"
yy1014:
	yych = *++cur;
	if (yych == 'I') goto yy1107;
	if (yych == 'i') goto yy1107;
	goto yy55;
yy1015:
	yyaccept = 14;
	yych = *(mar = ++cur);
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= '/') {
		if (yych <= '\v') {
			if (yych == '\t') goto yy1108;
			if (yych >= '\v') goto yy1108;
		} else {
			if (yych <= '\r') {
				if (yych >= '\r') goto yy1108;
			} else {
				if (yych == ' ') goto yy1108;
			}
		}
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') {
				if (yych <= '9') goto yy54;
			} else {
				if (yych == 'D') goto yy1110;
				goto yy54;
			}
		} else {
			if (yych <= 'c') {
				if (yych >= 'a') goto yy54;
			} else {
				if (yych <= 'd') goto yy1110;
				if (yych <= 'z') goto yy54;
			}
		}
	}
yy1016:
#line 286 "tokenizer.re"
	{ KW(ENDBLOCK) }
#line 6806 "tokenizer.cpp"
yy1017:
	yych = *++cur;
	if (yych == 'C') goto yy1111;
	if (yych == 'c') goto yy1111;
	goto yy55;
yy1018:
	yych = *++cur;
	if (yych == 'L') goto yy1112;
	if (yych == 'l') goto yy1112;
	goto yy55;
yy1019:
	yych = *++cur;
	if (yych == 'I') goto yy1114;
	if (yych == 'i') goto yy1114;
	goto yy55;
yy1020:
	yych = *++cur;
	if (yych == 'F') goto yy1115;
	if (yych == 'f') goto yy1115;
	goto yy55;
yy1021:
	yych = *++cur;
	if (yych == 'E') goto yy1116;
	if (yych == 'e') goto yy1116;
	goto yy55;
yy1022:
	yych = *++cur;
	if (yych == 'D') goto yy1118;
	if (yych == 'd') goto yy1118;
	goto yy55;
yy1023:
	yych = *++cur;
	if (yych == 'A') goto yy1119;
	if (yych == 'a') goto yy1119;
	goto yy55;
yy1024:
	yych = *++cur;
	if (yych == 'T') goto yy1120;
	if (yych == 't') goto yy1120;
	goto yy55;
yy1025:
	yych = *++cur;
	if (yych == 'D') goto yy1122;
	if (yych == 'd') goto yy1122;
	goto yy55;
yy1026:
	yych = *++cur;
	if (yych == 'U') goto yy1123;
	if (yych == 'u') goto yy1123;
	goto yy55;
yy1027:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 342 "tokenizer.re"
	{ KW(ENDWHERE) }
#line 6865 "tokenizer.cpp"
yy1029:
	yych = *++cur;
	if (yych == 'O') goto yy1124;
	if (yych == 'o') goto yy1124;
	goto yy55;
yy1030:
	yych = *++cur;
	if (yych == 'N') goto yy1125;
	if (yych == 'n') goto yy1125;
	goto yy55;
yy1031:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 356 "tokenizer.re"
	{ KW(EXTERNAL) }
#line 6884 "tokenizer.cpp"
yy1033:
	yych = *++cur;
	if (yych == 'D') goto yy1126;
	if (yych == 'd') goto yy1126;
	goto yy55;
yy1034:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 374 "tokenizer.re"
	{ KW(FUNCTION) }
#line 6898 "tokenizer.cpp"
yy1036:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 379 "tokenizer.re"
	{ KW(IMPLICIT) }
#line 6907 "tokenizer.cpp"
yy1038:
	yych = *++cur;
	if (yych <= '"') {
		if (yych <= '\f') {
			if (yych <= '\t') {
				if (yych <= 0x08) goto yy79;
				goto yy1038;
			} else {
				if (yych == '\v') goto yy1038;
				goto yy79;
			}
		} else {
			if (yych <= 0x1F) {
				if (yych <= '\r') goto yy1038;
				goto yy79;
			} else {
				if (yych <= ' ') goto yy1038;
				if (yych <= '!') goto yy79;
				goto yy1128;
			}
		}
	} else {
		if (yych <= '@') {
			if (yych <= '\'') {
				if (yych <= '&') goto yy79;
				goto yy1130;
			} else {
				if (yych <= '/') goto yy79;
				if (yych <= '9') goto yy1132;
				goto yy79;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'Z') goto yy1134;
				if (yych <= '^') goto yy79;
				goto yy1134;
			} else {
				if (yych <= '`') goto yy79;
				if (yych <= 'z') goto yy1134;
				goto yy79;
			}
		}
	}
yy1040:
	yych = *++cur;
	if (yych == 'E') goto yy1136;
	if (yych == 'e') goto yy1136;
	goto yy55;
yy1041:
	yych = *++cur;
	if (yych == 'C') goto yy1138;
	if (yych == 'c') goto yy1138;
	goto yy55;
yy1042:
	yych = *++cur;
	if (yych == 'I') goto yy1140;
	if (yych == 'i') goto yy1140;
	goto yy55;
yy1043:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 400 "tokenizer.re"
	{ KW(NAMELIST) }
#line 6974 "tokenizer.cpp"
yy1045:
	yych = *++cur;
	if (yych == 'I') goto yy1141;
	if (yych == 'i') goto yy1141;
	goto yy55;
yy1046:
	yych = *++cur;
	if (yych == 'R') goto yy1142;
	if (yych == 'r') goto yy1142;
	goto yy55;
yy1047:
	yych = *++cur;
	if (yych == 'R') goto yy1143;
	if (yych == 'r') goto yy1143;
	goto yy55;
yy1048:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 409 "tokenizer.re"
	{ KW(OPERATOR) }
#line 6998 "tokenizer.cpp"
yy1050:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 410 "tokenizer.re"
	{ KW(OPTIONAL) }
#line 7007 "tokenizer.cpp"
yy1052:
	yych = *++cur;
	if (yych == 'R') goto yy1144;
	if (yych == 'r') goto yy1144;
	goto yy55;
yy1053:
	yych = *++cur;
	if (yych == 'N') goto yy1146;
	if (yych == 'n') goto yy1146;
	goto yy55;
yy1054:
	yych = *++cur;
	if (yych == 'E') goto yy1148;
	if (yych == 'e') goto yy1148;
	goto yy55;
yy1055:
	yych = *++cur;
	if (yych == 'D') goto yy1150;
	if (yych == 'd') goto yy1150;
	goto yy55;
yy1056:
	yych = *++cur;
	if (yych == 'E') goto yy1152;
	if (yych == 'e') goto yy1152;
	goto yy55;
yy1057:
	yych = *++cur;
	if (yych == 'S') goto yy1154;
	if (yych == 's') goto yy1154;
	goto yy55;
yy1058:
	yych = *++cur;
	if (yych == 'N') goto yy1155;
	if (yych == 'n') goto yy1155;
	goto yy55;
yy1059:
	yych = *++cur;
	if (yych == 'P') goto yy1156;
	if (yych == 'p') goto yy1156;
	goto yy55;
yy1060:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 438 "tokenizer.re"
	{ KW(SEQUENCE) }
#line 7056 "tokenizer.cpp"
yy1062:
	yych = *++cur;
	if (yych == 'E') goto yy1157;
	if (yych == 'e') goto yy1157;
	goto yy55;
yy1063:
	yych = *++cur;
	if (yych == 'N') goto yy1159;
	if (yych == 'n') goto yy1159;
	goto yy55;
yy1064:
	yych = *++cur;
	if (yych == 'B') goto yy1160;
	if (yych == 'b') goto yy1160;
	goto yy55;
yy1065:
	yych = *++cur;
	if (yych == 'T') goto yy1161;
	if (yych == 't') goto yy1161;
	goto yy55;
yy1066:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 455 "tokenizer.re"
	{ KW(VOLATILE) }
#line 7085 "tokenizer.cpp"
yy1068:
	yych = *++cur;
	if (yych <= '/') goto yy855;
	if (yych <= '9') goto yy1068;
	goto yy855;
yy1070:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy855;
		if (yych <= '9') goto yy1070;
		if (yych <= '@') goto yy855;
		goto yy1070;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy855;
			goto yy1070;
		} else {
			if (yych <= '`') goto yy855;
			if (yych <= 'z') goto yy1070;
			goto yy855;
		}
	}
yy1072:
	yych = *++cur;
	if (yych == 'L') goto yy1162;
	if (yych == 'l') goto yy1162;
	goto yy55;
yy1073:
	yych = *++cur;
	if (yych == 'T') goto yy1163;
	if (yych == 't') goto yy1163;
	goto yy55;
yy1074:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 234 "tokenizer.re"
	{ KW(ASSOCIATE) }
#line 7126 "tokenizer.cpp"
yy1076:
	yych = *++cur;
	if (yych == 'O') goto yy1165;
	if (yych == 'o') goto yy1165;
	goto yy55;
yy1077:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 236 "tokenizer.re"
	{ KW(BACKSPACE) }
#line 7140 "tokenizer.cpp"
yy1079:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 241 "tokenizer.re"
	{ KW(CHARACTER) }
#line 7149 "tokenizer.cpp"
yy1081:
	yych = *++cur;
	if (yych == 'O') goto yy1166;
	if (yych == 'o') goto yy1166;
	goto yy55;
yy1082:
	yych = *++cur;
	if (yych == 'T') goto yy1167;
	if (yych == 't') goto yy1167;
	goto yy55;
yy1083:
	yych = *++cur;
	if (yych == 'S') goto yy1169;
	if (yych == 's') goto yy1169;
	goto yy55;
yy1084:
	yych = *++cur;
	if (yych == 'E') goto yy1171;
	if (yych == 'e') goto yy1171;
	goto yy55;
yy1085:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 257 "tokenizer.re"
	{ KW(DIMENSION) }
#line 7178 "tokenizer.cpp"
yy1087:
	yych = *++cur;
	if (yych == 'C') goto yy1173;
	if (yych == 'c') goto yy1173;
	goto yy55;
yy1088:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 269 "tokenizer.re"
	{ KW(ELEMENTAL) }
#line 7192 "tokenizer.cpp"
yy1090:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 272 "tokenizer.re"
	{ KW(ELSEWHERE) }
#line 7201 "tokenizer.cpp"
yy1092:
	yych = *++cur;
	if (yych == 'I') goto yy1174;
	if (yych == 'i') goto yy1174;
	goto yy79;
yy1093:
	yyaccept = 15;
	yych = *(mar = ++cur);
	if (yych <= '\r') {
		if (yych <= '\n') {
			if (yych == '\t') goto yy1175;
		} else {
			if (yych != '\f') goto yy1175;
		}
	} else {
		if (yych <= 'C') {
			if (yych == ' ') goto yy1175;
		} else {
			if (yych <= 'D') goto yy1177;
			if (yych == 'd') goto yy1177;
		}
	}
yy1094:
#line 285 "tokenizer.re"
	{ KW(END_BLOCK) }
#line 7227 "tokenizer.cpp"
yy1095:
	yych = *++cur;
	if (yych == 'C') goto yy1178;
	if (yych == 'c') goto yy1178;
	goto yy79;
yy1096:
	yych = *++cur;
	if (yych == 'L') goto yy1179;
	if (yych == 'l') goto yy1179;
	goto yy79;
yy1097:
	yych = *++cur;
	if (yych == 'I') goto yy1181;
	if (yych == 'i') goto yy1181;
	goto yy79;
yy1098:
	yych = *++cur;
	if (yych == 'F') goto yy1182;
	if (yych == 'f') goto yy1182;
	goto yy79;
yy1099:
	yych = *++cur;
	if (yych == 'E') goto yy1183;
	if (yych == 'e') goto yy1183;
	goto yy79;
yy1100:
	yych = *++cur;
	if (yych == 'D') goto yy1185;
	if (yych == 'd') goto yy1185;
	goto yy79;
yy1101:
	yych = *++cur;
	if (yych == 'A') goto yy1186;
	if (yych == 'a') goto yy1186;
	goto yy79;
yy1102:
	yych = *++cur;
	if (yych == 'T') goto yy1187;
	if (yych == 't') goto yy1187;
	goto yy79;
yy1103:
	yych = *++cur;
	if (yych == 'D') goto yy1189;
	if (yych == 'd') goto yy1189;
	goto yy79;
yy1104:
	yych = *++cur;
	if (yych == 'U') goto yy1190;
	if (yych == 'u') goto yy1190;
	goto yy79;
yy1105:
	++cur;
#line 341 "tokenizer.re"
	{ KW(END_WHERE) }
#line 7282 "tokenizer.cpp"
yy1107:
	yych = *++cur;
	if (yych == 'A') goto yy1191;
	if (yych == 'a') goto yy1191;
	goto yy55;
yy1108:
	yych = *++cur;
	if (yych <= '\r') {
		if (yych <= '\n') {
			if (yych == '\t') goto yy1108;
			goto yy79;
		} else {
			if (yych == '\f') goto yy79;
			goto yy1108;
		}
	} else {
		if (yych <= 'C') {
			if (yych == ' ') goto yy1108;
			goto yy79;
		} else {
			if (yych <= 'D') goto yy1192;
			if (yych == 'd') goto yy1192;
			goto yy79;
		}
	}
yy1110:
	yych = *++cur;
	if (yych == 'A') goto yy1193;
	if (yych == 'a') goto yy1193;
	goto yy55;
yy1111:
	yych = *++cur;
	if (yych == 'A') goto yy1194;
	if (yych == 'a') goto yy1194;
	goto yy55;
yy1112:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 315 "tokenizer.re"
	{ KW(ENDFORALL) }
#line 7326 "tokenizer.cpp"
yy1114:
	yych = *++cur;
	if (yych == 'O') goto yy1195;
	if (yych == 'o') goto yy1195;
	goto yy55;
yy1115:
	yych = *++cur;
	if (yych == 'A') goto yy1196;
	if (yych == 'a') goto yy1196;
	goto yy55;
yy1116:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 280 "tokenizer.re"
	{ KW(ENDMODULE) }
#line 7345 "tokenizer.cpp"
yy1118:
	yych = *++cur;
	if (yych == 'U') goto yy1197;
	if (yych == 'u') goto yy1197;
	goto yy55;
yy1119:
	yych = *++cur;
	if (yych == 'M') goto yy1198;
	if (yych == 'm') goto yy1198;
	goto yy55;
yy1120:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 306 "tokenizer.re"
	{ KW(ENDSELECT) }
#line 7364 "tokenizer.cpp"
yy1122:
	yych = *++cur;
	if (yych == 'U') goto yy1200;
	if (yych == 'u') goto yy1200;
	goto yy55;
yy1123:
	yych = *++cur;
	if (yych == 'T') goto yy1201;
	if (yych == 't') goto yy1201;
	goto yy55;
yy1124:
	yych = *++cur;
	if (yych == 'R') goto yy1202;
	if (yych == 'r') goto yy1202;
	goto yy55;
yy1125:
	yych = *++cur;
	if (yych == 'C') goto yy1204;
	if (yych == 'c') goto yy1204;
	goto yy55;
yy1126:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 373 "tokenizer.re"
	{ KW(FORMATTED) }
#line 7393 "tokenizer.cpp"
yy1128:
	yych = *++cur;
	if (yych <= 0x00) goto yy79;
	if (yych == '"') goto yy1205;
	goto yy1128;
yy1130:
	yych = *++cur;
	if (yych <= 0x00) goto yy79;
	if (yych == '\'') goto yy1207;
	goto yy1130;
yy1132:
	yych = *++cur;
	if (yych <= '/') goto yy79;
	if (yych <= '9') goto yy1132;
	if (yych == '_') goto yy1209;
	goto yy79;
yy1134:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy79;
		if (yych <= '9') goto yy1134;
		if (yych <= '@') goto yy79;
		goto yy1134;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy79;
			goto yy1210;
		} else {
			if (yych <= '`') goto yy79;
			if (yych <= 'z') goto yy1134;
			goto yy79;
		}
	}
yy1136:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 389 "tokenizer.re"
	{ KW(INTERFACE) }
#line 7435 "tokenizer.cpp"
yy1138:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 390 "tokenizer.re"
	{ KW(INTRINSIC) }
#line 7444 "tokenizer.cpp"
yy1140:
	yych = *++cur;
	if (yych == 'T') goto yy1212;
	if (yych == 't') goto yy1212;
	goto yy55;
yy1141:
	yych = *++cur;
	if (yych == 'N') goto yy1214;
	if (yych == 'n') goto yy1214;
	goto yy55;
yy1142:
	yych = *++cur;
	if (yych == 'I') goto yy1215;
	if (yych == 'i') goto yy1215;
	goto yy55;
yy1143:
	yych = *++cur;
	if (yych == 'S') goto yy1216;
	if (yych == 's') goto yy1216;
	goto yy55;
yy1144:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 412 "tokenizer.re"
	{ KW(PARAMETER) }
#line 7473 "tokenizer.cpp"
yy1146:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 416 "tokenizer.re"
	{ KW(PRECISION) }
#line 7482 "tokenizer.cpp"
yy1148:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 419 "tokenizer.re"
	{ KW(PROCEDURE) }
#line 7491 "tokenizer.cpp"
yy1150:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 421 "tokenizer.re"
	{ KW(PROTECTED) }
#line 7500 "tokenizer.cpp"
yy1152:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 428 "tokenizer.re"
	{ KW(RECURSIVE) }
#line 7509 "tokenizer.cpp"
yy1154:
	yych = *++cur;
	if (yych == 'E') goto yy1217;
	if (yych == 'e') goto yy1217;
	goto yy55;
yy1155:
	yych = *++cur;
	if (yych == 'K') goto yy1219;
	if (yych == 'k') goto yy1219;
	goto yy55;
yy1156:
	yych = *++cur;
	if (yych == 'E') goto yy1221;
	if (yych == 'e') goto yy1221;
	goto yy55;
yy1157:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 443 "tokenizer.re"
	{ KW(SUBMODULE) }
#line 7533 "tokenizer.cpp"
yy1159:
	yych = *++cur;
	if (yych == 'E') goto yy1223;
	if (yych == 'e') goto yy1223;
	goto yy55;
yy1160:
	yych = *++cur;
	if (yych == 'E') goto yy1225;
	if (yych == 'e') goto yy1225;
	goto yy55;
yy1161:
	yych = *++cur;
	if (yych == 'E') goto yy1226;
	if (yych == 'e') goto yy1226;
	goto yy55;
yy1162:
	yych = *++cur;
	if (yych == 'E') goto yy1227;
	if (yych == 'e') goto yy1227;
	goto yy55;
yy1163:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 233 "tokenizer.re"
	{ KW(ASSIGNMENT) }
#line 7562 "tokenizer.cpp"
yy1165:
	yych = *++cur;
	if (yych == 'U') goto yy1229;
	if (yych == 'u') goto yy1229;
	goto yy55;
yy1166:
	yych = *++cur;
	if (yych == 'N') goto yy1230;
	if (yych == 'n') goto yy1230;
	goto yy55;
yy1167:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 247 "tokenizer.re"
	{ KW(CONCURRENT) }
#line 7581 "tokenizer.cpp"
yy1169:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 249 "tokenizer.re"
	{ KW(CONTIGUOUS) }
#line 7590 "tokenizer.cpp"
yy1171:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 254 "tokenizer.re"
	{ KW(DEALLOCATE) }
#line 7599 "tokenizer.cpp"
yy1173:
	yych = *++cur;
	if (yych == 'I') goto yy1232;
	if (yych == 'i') goto yy1232;
	goto yy55;
yy1174:
	yych = *++cur;
	if (yych == 'A') goto yy1233;
	if (yych == 'a') goto yy1233;
	goto yy79;
yy1175:
	yych = *++cur;
	if (yych <= '\r') {
		if (yych <= '\n') {
			if (yych == '\t') goto yy1175;
			goto yy79;
		} else {
			if (yych == '\f') goto yy79;
			goto yy1175;
		}
	} else {
		if (yych <= 'C') {
			if (yych == ' ') goto yy1175;
			goto yy79;
		} else {
			if (yych <= 'D') goto yy1234;
			if (yych == 'd') goto yy1234;
			goto yy79;
		}
	}
yy1177:
	yych = *++cur;
	if (yych == 'A') goto yy1235;
	if (yych == 'a') goto yy1235;
	goto yy79;
yy1178:
	yych = *++cur;
	if (yych == 'A') goto yy1236;
	if (yych == 'a') goto yy1236;
	goto yy79;
yy1179:
	++cur;
#line 314 "tokenizer.re"
	{ KW(END_FORALL) }
#line 7644 "tokenizer.cpp"
yy1181:
	yych = *++cur;
	if (yych == 'O') goto yy1237;
	if (yych == 'o') goto yy1237;
	goto yy79;
yy1182:
	yych = *++cur;
	if (yych == 'A') goto yy1238;
	if (yych == 'a') goto yy1238;
	goto yy79;
yy1183:
	++cur;
#line 279 "tokenizer.re"
	{ KW(END_MODULE) }
#line 7659 "tokenizer.cpp"
yy1185:
	yych = *++cur;
	if (yych == 'U') goto yy1239;
	if (yych == 'u') goto yy1239;
	goto yy79;
yy1186:
	yych = *++cur;
	if (yych == 'M') goto yy1240;
	if (yych == 'm') goto yy1240;
	goto yy79;
yy1187:
	++cur;
#line 305 "tokenizer.re"
	{ KW(END_SELECT) }
#line 7674 "tokenizer.cpp"
yy1189:
	yych = *++cur;
	if (yych == 'U') goto yy1242;
	if (yych == 'u') goto yy1242;
	goto yy79;
yy1190:
	yych = *++cur;
	if (yych == 'T') goto yy1243;
	if (yych == 't') goto yy1243;
	goto yy79;
yy1191:
	yych = *++cur;
	if (yych == 'T') goto yy1244;
	if (yych == 't') goto yy1244;
	goto yy55;
yy1192:
	yych = *++cur;
	if (yych == 'A') goto yy1245;
	if (yych == 'a') goto yy1245;
	goto yy79;
yy1193:
	yych = *++cur;
	if (yych == 'T') goto yy1246;
	if (yych == 't') goto yy1246;
	goto yy55;
yy1194:
	yych = *++cur;
	if (yych == 'L') goto yy1247;
	if (yych == 'l') goto yy1247;
	goto yy55;
yy1195:
	yych = *++cur;
	if (yych == 'N') goto yy1249;
	if (yych == 'n') goto yy1249;
	goto yy55;
yy1196:
	yych = *++cur;
	if (yych == 'C') goto yy1251;
	if (yych == 'c') goto yy1251;
	goto yy55;
yy1197:
	yych = *++cur;
	if (yych == 'R') goto yy1252;
	if (yych == 'r') goto yy1252;
	goto yy55;
yy1198:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 277 "tokenizer.re"
	{ KW(ENDPROGRAM) }
#line 7728 "tokenizer.cpp"
yy1200:
	yych = *++cur;
	if (yych == 'L') goto yy1253;
	if (yych == 'l') goto yy1253;
	goto yy55;
yy1201:
	yych = *++cur;
	if (yych == 'I') goto yy1254;
	if (yych == 'i') goto yy1254;
	goto yy55;
yy1202:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 349 "tokenizer.re"
	{ KW(ENUMERATOR) }
#line 7747 "tokenizer.cpp"
yy1204:
	yych = *++cur;
	if (yych == 'E') goto yy1255;
	if (yych == 'e') goto yy1255;
	goto yy55;
yy1205:
	yyaccept = 16;
	yych = *(mar = ++cur);
	if (yych == '"') goto yy1128;
yy1206:
#line 604 "tokenizer.re"
	{ continue; }
#line 7760 "tokenizer.cpp"
yy1207:
	yyaccept = 17;
	yych = *(mar = ++cur);
	if (yych == '\'') goto yy1130;
yy1208:
#line 605 "tokenizer.re"
	{ continue; }
#line 7768 "tokenizer.cpp"
yy1209:
	yych = *++cur;
	if (yych == '"') goto yy1128;
	if (yych == '\'') goto yy1130;
	goto yy79;
yy1210:
	yych = *++cur;
	if (yych <= '9') {
		if (yych <= '&') {
			if (yych == '"') goto yy1128;
			goto yy79;
		} else {
			if (yych <= '\'') goto yy1130;
			if (yych <= '/') goto yy79;
			goto yy1134;
		}
	} else {
		if (yych <= '^') {
			if (yych <= '@') goto yy79;
			if (yych <= 'Z') goto yy1134;
			goto yy79;
		} else {
			if (yych <= '_') goto yy1210;
			if (yych <= '`') goto yy79;
			if (yych <= 'z') goto yy1134;
			goto yy79;
		}
	}
yy1212:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 395 "tokenizer.re"
	{ KW(LOCAL_INIT) }
#line 7805 "tokenizer.cpp"
yy1214:
	yych = *++cur;
	if (yych == 'S') goto yy1257;
	if (yych == 's') goto yy1257;
	goto yy55;
yy1215:
	yych = *++cur;
	if (yych == 'D') goto yy1258;
	if (yych == 'd') goto yy1258;
	goto yy55;
yy1216:
	yych = *++cur;
	if (yych == 'I') goto yy1259;
	if (yych == 'i') goto yy1259;
	goto yy55;
yy1217:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 435 "tokenizer.re"
	{ KW(SELECT_CASE) }
#line 7829 "tokenizer.cpp"
yy1219:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 436 "tokenizer.re"
	{ KW(SELECT_RANK) }
#line 7838 "tokenizer.cpp"
yy1221:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 437 "tokenizer.re"
	{ KW(SELECT_TYPE) }
#line 7847 "tokenizer.cpp"
yy1223:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 444 "tokenizer.re"
	{ KW(SUBROUTINE) }
#line 7856 "tokenizer.cpp"
yy1225:
	yych = *++cur;
	if (yych == 'R') goto yy1260;
	if (yych == 'r') goto yy1260;
	goto yy55;
yy1226:
	yych = *++cur;
	if (yych == 'D') goto yy1262;
	if (yych == 'd') goto yy1262;
	goto yy55;
yy1227:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 230 "tokenizer.re"
	{ KW(ALLOCATABLE) }
#line 7875 "tokenizer.cpp"
yy1229:
	yych = *++cur;
	if (yych == 'S') goto yy1264;
	if (yych == 's') goto yy1264;
	goto yy55;
yy1230:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 244 "tokenizer.re"
	{ KW(CODIMENSION) }
#line 7889 "tokenizer.cpp"
yy1232:
	yych = *++cur;
	if (yych == 'S') goto yy1266;
	if (yych == 's') goto yy1266;
	goto yy55;
yy1233:
	yych = *++cur;
	if (yych == 'T') goto yy1267;
	if (yych == 't') goto yy1267;
	goto yy79;
yy1234:
	yych = *++cur;
	if (yych == 'A') goto yy1268;
	if (yych == 'a') goto yy1268;
	goto yy79;
yy1235:
	yych = *++cur;
	if (yych == 'T') goto yy1269;
	if (yych == 't') goto yy1269;
	goto yy79;
yy1236:
	yych = *++cur;
	if (yych == 'L') goto yy1270;
	if (yych == 'l') goto yy1270;
	goto yy79;
yy1237:
	yych = *++cur;
	if (yych == 'N') goto yy1272;
	if (yych == 'n') goto yy1272;
	goto yy79;
yy1238:
	yych = *++cur;
	if (yych == 'C') goto yy1274;
	if (yych == 'c') goto yy1274;
	goto yy79;
yy1239:
	yych = *++cur;
	if (yych == 'R') goto yy1275;
	if (yych == 'r') goto yy1275;
	goto yy79;
yy1240:
	++cur;
#line 276 "tokenizer.re"
	{ KW(END_PROGRAM) }
#line 7934 "tokenizer.cpp"
yy1242:
	yych = *++cur;
	if (yych == 'L') goto yy1276;
	if (yych == 'l') goto yy1276;
	goto yy79;
yy1243:
	yych = *++cur;
	if (yych == 'I') goto yy1277;
	if (yych == 'i') goto yy1277;
	goto yy79;
yy1244:
	yych = *++cur;
	if (yych == 'E') goto yy1278;
	if (yych == 'e') goto yy1278;
	goto yy55;
yy1245:
	yych = *++cur;
	if (yych == 'T') goto yy1280;
	if (yych == 't') goto yy1280;
	goto yy79;
yy1246:
	yych = *++cur;
	if (yych == 'A') goto yy1281;
	if (yych == 'a') goto yy1281;
	goto yy55;
yy1247:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 312 "tokenizer.re"
	{ KW(ENDCRITICAL) }
#line 7968 "tokenizer.cpp"
yy1249:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 297 "tokenizer.re"
	{ KW(ENDFUNCTION) }
#line 7977 "tokenizer.cpp"
yy1251:
	yych = *++cur;
	if (yych == 'E') goto yy1283;
	if (yych == 'e') goto yy1283;
	goto yy55;
yy1252:
	yych = *++cur;
	if (yych == 'E') goto yy1285;
	if (yych == 'e') goto yy1285;
	goto yy55;
yy1253:
	yych = *++cur;
	if (yych == 'E') goto yy1287;
	if (yych == 'e') goto yy1287;
	goto yy55;
yy1254:
	yych = *++cur;
	if (yych == 'N') goto yy1289;
	if (yych == 'n') goto yy1289;
	goto yy55;
yy1255:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 350 "tokenizer.re"
	{ KW(EQUIVALENCE) }
#line 8006 "tokenizer.cpp"
yy1257:
	yych = *++cur;
	if (yych == 'I') goto yy1290;
	if (yych == 'i') goto yy1290;
	goto yy55;
yy1258:
	yych = *++cur;
	if (yych == 'A') goto yy1291;
	if (yych == 'a') goto yy1291;
	goto yy55;
yy1259:
	yych = *++cur;
	if (yych == 'V') goto yy1292;
	if (yych == 'v') goto yy1292;
	goto yy55;
yy1260:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 448 "tokenizer.re"
	{ KW(TEAM_NUMBER) }
#line 8030 "tokenizer.cpp"
yy1262:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 452 "tokenizer.re"
	{ KW(UNFORMATTED) }
#line 8039 "tokenizer.cpp"
yy1264:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 235 "tokenizer.re"
	{ KW(ASYNCHRONOUS) }
#line 8048 "tokenizer.cpp"
yy1266:
	yych = *++cur;
	if (yych == 'I') goto yy1293;
	if (yych == 'i') goto yy1293;
	goto yy55;
yy1267:
	yych = *++cur;
	if (yych == 'E') goto yy1294;
	if (yych == 'e') goto yy1294;
	goto yy79;
yy1268:
	yych = *++cur;
	if (yych == 'T') goto yy1296;
	if (yych == 't') goto yy1296;
	goto yy79;
yy1269:
	yych = *++cur;
	if (yych == 'A') goto yy1297;
	if (yych == 'a') goto yy1297;
	goto yy79;
yy1270:
	++cur;
#line 311 "tokenizer.re"
	{ KW(END_CRITICAL) }
#line 8073 "tokenizer.cpp"
yy1272:
	++cur;
#line 296 "tokenizer.re"
	{ KW(END_FUNCTION) }
#line 8078 "tokenizer.cpp"
yy1274:
	yych = *++cur;
	if (yych == 'E') goto yy1299;
	if (yych == 'e') goto yy1299;
	goto yy79;
yy1275:
	yych = *++cur;
	if (yych == 'E') goto yy1301;
	if (yych == 'e') goto yy1301;
	goto yy79;
yy1276:
	yych = *++cur;
	if (yych == 'E') goto yy1303;
	if (yych == 'e') goto yy1303;
	goto yy79;
yy1277:
	yych = *++cur;
	if (yych == 'N') goto yy1305;
	if (yych == 'n') goto yy1305;
	goto yy79;
yy1278:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 309 "tokenizer.re"
	{ KW(ENDASSOCIATE) }
#line 8107 "tokenizer.cpp"
yy1280:
	yych = *++cur;
	if (yych == 'A') goto yy1306;
	if (yych == 'a') goto yy1306;
	goto yy79;
yy1281:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 291 "tokenizer.re"
	{ KW(ENDBLOCKDATA) }
#line 8121 "tokenizer.cpp"
yy1283:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 321 "tokenizer.re"
	{ KW(ENDINTERFACE) }
#line 8130 "tokenizer.cpp"
yy1285:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 300 "tokenizer.re"
	{ KW(ENDPROCEDURE) }
#line 8139 "tokenizer.cpp"
yy1287:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 283 "tokenizer.re"
	{ KW(ENDSUBMODULE) }
#line 8148 "tokenizer.cpp"
yy1289:
	yych = *++cur;
	if (yych == 'E') goto yy1308;
	if (yych == 'e') goto yy1308;
	goto yy55;
yy1290:
	yych = *++cur;
	if (yych == 'C') goto yy1310;
	if (yych == 'c') goto yy1310;
	goto yy55;
yy1291:
	yych = *++cur;
	if (yych == 'B') goto yy1312;
	if (yych == 'b') goto yy1312;
	goto yy55;
yy1292:
	yych = *++cur;
	if (yych == 'E') goto yy1313;
	if (yych == 'e') goto yy1313;
	goto yy55;
yy1293:
	yych = *++cur;
	if (yych == 'O') goto yy1315;
	if (yych == 'o') goto yy1315;
	goto yy55;
yy1294:
	++cur;
#line 308 "tokenizer.re"
	{ KW(END_ASSOCIATE) }
#line 8178 "tokenizer.cpp"
yy1296:
	yych = *++cur;
	if (yych == 'A') goto yy1316;
	if (yych == 'a') goto yy1316;
	goto yy79;
yy1297:
	++cur;
#line 290 "tokenizer.re"
	{ KW(END_BLOCK_DATA) }
#line 8188 "tokenizer.cpp"
yy1299:
	++cur;
#line 320 "tokenizer.re"
	{ KW(END_INTERFACE) }
#line 8193 "tokenizer.cpp"
yy1301:
	++cur;
#line 299 "tokenizer.re"
	{ KW(END_PROCEDURE) }
#line 8198 "tokenizer.cpp"
yy1303:
	++cur;
#line 282 "tokenizer.re"
	{ KW(END_SUBMODULE) }
#line 8203 "tokenizer.cpp"
yy1305:
	yych = *++cur;
	if (yych == 'E') goto yy1318;
	if (yych == 'e') goto yy1318;
	goto yy79;
yy1306:
	++cur;
#line 289 "tokenizer.re"
	{ KW(END_BLOCK_DATA) }
#line 8213 "tokenizer.cpp"
yy1308:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 294 "tokenizer.re"
	{ KW(ENDSUBROUTINE) }
#line 8222 "tokenizer.cpp"
yy1310:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 402 "tokenizer.re"
	{ KW(NON_INTRINSIC) }
#line 8231 "tokenizer.cpp"
yy1312:
	yych = *++cur;
	if (yych == 'L') goto yy1320;
	if (yych == 'l') goto yy1320;
	goto yy55;
yy1313:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 404 "tokenizer.re"
	{ KW(NON_RECURSIVE) }
#line 8245 "tokenizer.cpp"
yy1315:
	yych = *++cur;
	if (yych == 'N') goto yy1321;
	if (yych == 'n') goto yy1321;
	goto yy55;
yy1316:
	++cur;
#line 288 "tokenizer.re"
	{ KW(END_BLOCK_DATA) }
#line 8255 "tokenizer.cpp"
yy1318:
	++cur;
#line 293 "tokenizer.re"
	{ KW(END_SUBROUTINE) }
#line 8260 "tokenizer.cpp"
yy1320:
	yych = *++cur;
	if (yych == 'E') goto yy1323;
	if (yych == 'e') goto yy1323;
	goto yy55;
yy1321:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 268 "tokenizer.re"
	{ KW(DOUBLE_PRECISION) }
#line 8274 "tokenizer.cpp"
yy1323:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 403 "tokenizer.re"
	{ KW(NON_OVERRIDABLE) }
#line 8283 "tokenizer.cpp"
}
#line 612 "tokenizer.re"

    }
}

std::string token(unsigned char *tok, unsigned char* cur)
{
    return std::string((char *)tok, cur - tok);
}

void token_loc(Location &loc)
{
    loc.first_line = 1;
    loc.last_line = 1;
    loc.first_column = 1;
    loc.last_column = 1;
}

void lex_format(unsigned char *&cur, Location &loc,
        unsigned char *&start) {
    int num_paren = 0;
    for (;;) {
        unsigned char *tok = cur;
        unsigned char *mar;
        
#line 8310 "tokenizer.cpp"
{
	unsigned char yych;
	unsigned int yyaccept = 0;
	static const unsigned char yybm[] = {
		  0, 208, 208, 208, 208, 208, 208, 208, 
		208, 244, 176, 244, 208, 244, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		244, 208, 192, 208, 208, 208, 208,  80, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		216, 216, 216, 216, 216, 216, 216, 216, 
		216, 216, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
	};
	yych = *cur;
	if (yybm[0+yych] & 4) {
		goto yy1331;
	}
	switch (yych) {
	case 0x00:	goto yy1327;
	case '"':	goto yy1334;
	case '&':	goto yy1335;
	case '\'':	goto yy1336;
	case '(':	goto yy1337;
	case ')':	goto yy1339;
	case '*':	goto yy1341;
	case ',':	goto yy1342;
	case '/':
	case ':':	goto yy1344;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy1346;
	case 'A':
	case 'a':	goto yy1347;
	case 'B':
	case 'I':
	case 'O':
	case 'Z':
	case 'b':
	case 'i':
	case 'o':
	case 'z':	goto yy1350;
	case 'D':
	case 'F':
	case 'd':
	case 'f':	goto yy1351;
	case 'E':
	case 'e':	goto yy1352;
	case 'G':
	case 'g':	goto yy1353;
	case 'L':
	case 'l':	goto yy1354;
	case 'P':
	case 'p':	goto yy1355;
	case 'T':
	case 't':	goto yy1356;
	case 'X':
	case 'x':	goto yy1357;
	default:	goto yy1329;
	}
yy1327:
	++cur;
#line 707 "tokenizer.re"
	{
                token_loc(loc);
                std::string t = token(tok, cur);
                throw LFortran::TokenizerError(
                    "End of file not expected in `format` statemenet", loc, t);
            }
#line 8410 "tokenizer.cpp"
yy1329:
	++cur;
yy1330:
#line 673 "tokenizer.re"
	{
                token_loc(loc);
                std::string t = token(tok, cur);
                throw LFortran::TokenizerError("Token '" + t
                    + "' is not recognized in `format` statement", loc, t);
            }
#line 8421 "tokenizer.cpp"
yy1331:
	yych = *++cur;
	if (yybm[0+yych] & 4) {
		goto yy1331;
	}
#line 713 "tokenizer.re"
	{ continue; }
#line 8429 "tokenizer.cpp"
yy1334:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy1330;
	goto yy1359;
yy1335:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= '\f') {
		if (yych <= 0x08) goto yy1330;
		if (yych <= '\v') goto yy1364;
		goto yy1330;
	} else {
		if (yych <= '\r') goto yy1364;
		if (yych <= 0x1F) goto yy1330;
		if (yych <= '!') goto yy1364;
		goto yy1330;
	}
yy1336:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy1330;
	goto yy1371;
yy1337:
	++cur;
#line 679 "tokenizer.re"
	{
                if (num_paren == 0) {
                    num_paren++;
                    start = cur;
                    continue;
                } else {
                    cur--;
                    unsigned char *tmp;
                    lex_format(cur, loc, tmp);
                    continue;
                }
            }
#line 8468 "tokenizer.cpp"
yy1339:
	++cur;
#line 703 "tokenizer.re"
	{
                LFORTRAN_ASSERT(num_paren == 1);
                return;
            }
#line 8476 "tokenizer.cpp"
yy1341:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy1330;
			goto yy1374;
		} else {
			if (yych == '\v') goto yy1374;
			goto yy1330;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy1374;
			if (yych <= 0x1F) goto yy1330;
			goto yy1374;
		} else {
			if (yych == '(') goto yy1376;
			goto yy1330;
		}
	}
yy1342:
	++cur;
#line 714 "tokenizer.re"
	{ continue; }
#line 8502 "tokenizer.cpp"
yy1344:
	++cur;
yy1345:
#line 719 "tokenizer.re"
	{ continue; }
#line 8508 "tokenizer.cpp"
yy1346:
	yyaccept = 0;
	yych = *(mar = ++cur);
	switch (yych) {
	case '\t':
	case '\v':
	case '\r':
	case ' ':
	case '(':
	case '/':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'I':
	case 'L':
	case 'O':
	case 'P':
	case 'X':
	case 'Z':
	case 'a':
	case 'b':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'i':
	case 'l':
	case 'o':
	case 'p':
	case 'x':
	case 'z':	goto yy1383;
	default:	goto yy1330;
	}
yy1347:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy1347;
	}
yy1349:
#line 718 "tokenizer.re"
	{ continue; }
#line 8563 "tokenizer.cpp"
yy1350:
	yych = *++cur;
	if (yych <= '/') goto yy1330;
	if (yych <= '9') goto yy1389;
	goto yy1330;
yy1351:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= '/') goto yy1330;
	if (yych <= '9') goto yy1391;
	goto yy1330;
yy1352:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 'W') {
		if (yych <= 'M') {
			if (yych <= '/') goto yy1330;
			if (yych <= '9') goto yy1393;
			goto yy1330;
		} else {
			if (yych <= 'N') goto yy1395;
			if (yych == 'S') goto yy1395;
			goto yy1330;
		}
	} else {
		if (yych <= 'r') {
			if (yych <= 'X') goto yy1395;
			if (yych == 'n') goto yy1395;
			goto yy1330;
		} else {
			if (yych <= 's') goto yy1395;
			if (yych == 'x') goto yy1395;
			goto yy1330;
		}
	}
yy1353:
	yych = *++cur;
	if (yych <= '/') goto yy1330;
	if (yych <= '9') goto yy1396;
	goto yy1330;
yy1354:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy1347;
	}
	goto yy1330;
yy1355:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych <= 'D') goto yy1349;
	if (yych <= 'F') goto yy1385;
	if (yych <= 'd') goto yy1349;
	if (yych <= 'f') goto yy1385;
	goto yy1349;
yy1356:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 'Q') {
		if (yych <= '9') {
			if (yych <= '/') goto yy1330;
			goto yy1398;
		} else {
			if (yych == 'L') goto yy1400;
			goto yy1330;
		}
	} else {
		if (yych <= 'l') {
			if (yych <= 'R') goto yy1400;
			if (yych <= 'k') goto yy1330;
			goto yy1400;
		} else {
			if (yych == 'r') goto yy1400;
			goto yy1330;
		}
	}
yy1357:
	++cur;
	goto yy1349;
yy1358:
	yych = *++cur;
yy1359:
	if (yybm[0+yych] & 16) {
		goto yy1358;
	}
	if (yych >= 0x01) goto yy1361;
yy1360:
	cur = mar;
	if (yyaccept <= 2) {
		if (yyaccept <= 1) {
			if (yyaccept == 0) {
				goto yy1330;
			} else {
				goto yy1349;
			}
		} else {
			goto yy1362;
		}
	} else {
		if (yyaccept == 3) {
			goto yy1367;
		} else {
			goto yy1373;
		}
	}
yy1361:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych == '"') goto yy1358;
yy1362:
#line 716 "tokenizer.re"
	{ continue; }
#line 8675 "tokenizer.cpp"
yy1363:
	yych = *++cur;
yy1364:
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy1360;
			goto yy1363;
		} else {
			if (yych <= '\n') goto yy1365;
			if (yych <= '\v') goto yy1363;
			goto yy1360;
		}
	} else {
		if (yych <= 0x1F) {
			if (yych <= '\r') goto yy1363;
			goto yy1360;
		} else {
			if (yych <= ' ') goto yy1363;
			if (yych <= '!') goto yy1368;
			goto yy1360;
		}
	}
yy1365:
	yyaccept = 3;
	yych = *(mar = ++cur);
	if (yybm[0+yych] & 32) {
		goto yy1365;
	}
	if (yych <= 0x1F) goto yy1367;
	if (yych <= '!') goto yy1368;
	if (yych == '&') goto yy1401;
yy1367:
#line 715 "tokenizer.re"
	{ continue; }
#line 8710 "tokenizer.cpp"
yy1368:
	yych = *++cur;
	if (yybm[0+yych] & 64) {
		goto yy1368;
	}
	if (yych <= 0x00) goto yy1360;
	goto yy1365;
yy1370:
	yych = *++cur;
yy1371:
	if (yybm[0+yych] & 128) {
		goto yy1370;
	}
	if (yych <= 0x00) goto yy1360;
	yyaccept = 4;
	yych = *(mar = ++cur);
	if (yych == '\'') goto yy1370;
yy1373:
#line 717 "tokenizer.re"
	{ continue; }
#line 8731 "tokenizer.cpp"
yy1374:
	yych = *++cur;
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy1360;
			goto yy1374;
		} else {
			if (yych == '\v') goto yy1374;
			goto yy1360;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy1374;
			if (yych <= 0x1F) goto yy1360;
			goto yy1374;
		} else {
			if (yych != '(') goto yy1360;
		}
	}
yy1376:
	++cur;
#line 697 "tokenizer.re"
	{
                cur--;
                unsigned char *tmp;
                lex_format(cur, loc, tmp);
                continue;
            }
#line 8760 "tokenizer.cpp"
yy1378:
	yych = *++cur;
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy1360;
			goto yy1378;
		} else {
			if (yych == '\v') goto yy1378;
			goto yy1360;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy1378;
			if (yych <= 0x1F) goto yy1360;
			goto yy1378;
		} else {
			if (yych != '(') goto yy1360;
		}
	}
yy1380:
	++cur;
#line 691 "tokenizer.re"
	{
                cur--;
                unsigned char *tmp;
                lex_format(cur, loc, tmp);
                continue;
            }
#line 8789 "tokenizer.cpp"
yy1382:
	yych = *++cur;
yy1383:
	switch (yych) {
	case '\t':
	case '\v':
	case '\r':
	case ' ':	goto yy1378;
	case '(':	goto yy1380;
	case '/':	goto yy1344;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy1382;
	case 'A':
	case 'a':	goto yy1347;
	case 'B':
	case 'I':
	case 'O':
	case 'Z':
	case 'b':
	case 'i':
	case 'o':
	case 'z':	goto yy1384;
	case 'D':
	case 'F':
	case 'd':
	case 'f':	goto yy1385;
	case 'E':
	case 'e':	goto yy1386;
	case 'G':
	case 'g':	goto yy1387;
	case 'L':
	case 'l':	goto yy1388;
	case 'P':
	case 'p':	goto yy1355;
	case 'X':
	case 'x':	goto yy1357;
	default:	goto yy1360;
	}
yy1384:
	yych = *++cur;
	if (yych <= '/') goto yy1360;
	if (yych <= '9') goto yy1389;
	goto yy1360;
yy1385:
	yych = *++cur;
	if (yych <= '/') goto yy1360;
	if (yych <= '9') goto yy1391;
	goto yy1360;
yy1386:
	yych = *++cur;
	if (yych <= 'W') {
		if (yych <= 'M') {
			if (yych <= '/') goto yy1360;
			if (yych <= '9') goto yy1393;
			goto yy1360;
		} else {
			if (yych <= 'N') goto yy1395;
			if (yych == 'S') goto yy1395;
			goto yy1360;
		}
	} else {
		if (yych <= 'r') {
			if (yych <= 'X') goto yy1395;
			if (yych == 'n') goto yy1395;
			goto yy1360;
		} else {
			if (yych <= 's') goto yy1395;
			if (yych == 'x') goto yy1395;
			goto yy1360;
		}
	}
yy1387:
	yych = *++cur;
	if (yych <= '/') goto yy1360;
	if (yych <= '9') goto yy1396;
	goto yy1360;
yy1388:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy1347;
	}
	goto yy1360;
yy1389:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych == '.') goto yy1388;
	if (yych <= '/') goto yy1349;
	if (yych <= '9') goto yy1389;
	goto yy1349;
yy1391:
	yych = *++cur;
	if (yych == '.') goto yy1388;
	if (yych <= '/') goto yy1360;
	if (yych <= '9') goto yy1391;
	goto yy1360;
yy1393:
	yych = *++cur;
	if (yych == '.') goto yy1402;
	if (yych <= '/') goto yy1360;
	if (yych <= '9') goto yy1393;
	goto yy1360;
yy1395:
	yych = *++cur;
	if (yych <= '/') goto yy1360;
	if (yych <= '9') goto yy1393;
	goto yy1360;
yy1396:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych == '.') goto yy1402;
	if (yych <= '/') goto yy1349;
	if (yych <= '9') goto yy1396;
	goto yy1349;
yy1398:
	yych = *++cur;
	if (yych <= '/') goto yy1345;
	if (yych <= '9') goto yy1398;
	goto yy1345;
yy1400:
	yych = *++cur;
	if (yych <= '/') goto yy1360;
	if (yych <= '9') goto yy1398;
	goto yy1360;
yy1401:
	++cur;
	goto yy1367;
yy1402:
	yych = *++cur;
	if (yych <= '/') goto yy1360;
	if (yych >= ':') goto yy1360;
yy1403:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych <= 'D') {
		if (yych <= '/') goto yy1349;
		if (yych <= '9') goto yy1403;
		goto yy1349;
	} else {
		if (yych <= 'E') goto yy1388;
		if (yych == 'e') goto yy1388;
		goto yy1349;
	}
}
#line 720 "tokenizer.re"

    }
}

} // namespace LFortran
